Editor = {}
Test = {}
function Editor.load()
	editor = {}
	editor.bricks = {}
	editor.characters = {" ", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "-", "_", "ù", "é", "à", "è", "ç", "ñ", "ä", "ë", "ö", "ï", "ü", "â", "ê", "î", "ô", "û", "ù", "É", "À", "È", "Ç", "Ñ", "Ä", "Ë", "Ö", "Ï", "Ü", "Â", "Ê", "Î", "Ô", "Û"}
	editor.sets = {}
	item = {}
	editor.bg = love.graphics.newImage("gfx/editorbg.png")
	editor.grid = {}
	local x = -64
	local y = 97
	for i = 1, 180 do
		local t = {}
		x = x + 64
		if x == window.width then
			x = 0
			y = y + 32
		end
		t.x = x
		t.y = y
		table.insert(editor.grid, t)
	end
	editor.cell = love.graphics.newImage("gfx/grid.png")
	cursor = {x=562, y=728}
	item.x = pointer.x
	item.y = pointer.y
	item.ox = 0
	item.oy = 0
	item.scale = 1
	item.visible = false
	item.image = brick.blue
	editor.changes = false
	editor.active = "nothing"
	editor.brickSelected = love.graphics.newImage("gfx/brick_selected.png")
	editor.selected = editor.brickSelected
	editor.sx = 0
	editor.sy = 0
	editor.pointer = "nothing"
	-- Bricks variables -----------------------------------------------------------------------------
	editor.icon = {}
	editor.icon.blue = love.graphics.newImage("gfx/editor_brick_blue.png")
	editor.icon.cyan = love.graphics.newImage("gfx/editor_brick_cyan.png")
	editor.icon.gold = love.graphics.newImage("gfx/editor_brick_gold.png")
	editor.icon.green = love.graphics.newImage("gfx/editor_brick_green.png")
	editor.icon.grey = love.graphics.newImage("gfx/editor_brick_grey.png")
	editor.icon.orange = love.graphics.newImage("gfx/editor_brick_orange.png")
	editor.icon.purple = love.graphics.newImage("gfx/editor_brick_purple.png")
	editor.icon.red = love.graphics.newImage("gfx/editor_brick_red.png")
	editor.icon.white = love.graphics.newImage("gfx/editor_brick_white.png")
	editor.icon.yellow = love.graphics.newImage("gfx/editor_brick_yellow.png")
	editor.blue = collider:addRectangle(8, 725, 32, 16)
	editor.blue.type = "blue"
	editor.green = collider:addRectangle(56, 725, 32, 16)
	editor.green.type = "green"
	editor.red = collider:addRectangle(104, 725, 32, 16)
	editor.red.type = "red"
	editor.purple = collider:addRectangle(152, 725, 32, 16)
	editor.purple.type = "purple"
	editor.yellow = collider:addRectangle(8, 748, 32, 16)
	editor.yellow.type = "yellow"
	editor.grey = collider:addRectangle(200, 725, 32, 16)
	editor.grey.type = "grey"
	editor.cyan = collider:addRectangle(56, 748, 32, 16)
	editor.cyan.type = "cyan"
	editor.gold = collider:addRectangle(200, 748, 32, 16)
	editor.gold.type = "gold"
	editor.white = collider:addRectangle(104, 748, 32, 16)
	editor.white.type = "white"
	editor.orange = collider:addRectangle(152, 748, 32, 16)
	editor.orange.type = "orange"
	-- Bonus Variables ------------------------------------------------------------------------------
	editor.bonus = {}
	editor.bonus.x = 0
	editor.bonus.y = 0
	editor.bonus.visible = false
	editor.bonus.panel = love.graphics.newImage("gfx/bonus_panel.png")
	editor.bonus.button = {}
	editor.bonus.button.default = love.graphics.newImage("gfx/bonus_button_default.png")
	editor.bonus.button.selected = love.graphics.newImage("gfx/bonus_button_selected.png")
	editor.bonus.box = collider:addRectangle(250, 720, 49, 49)
	editor.bonus.box.type = "bonus"
	editor.bonus.glue = {}
	editor.bonus.glue.image = love.graphics.newImage("gfx/bonus_glue.png")
	editor.bonus.glue.box = collider:addRectangle(187, 640, 38, 36)
	editor.bonus.glue.box.type = "glue"
	editor.bonus.super = {}
	editor.bonus.super.image = love.graphics.newImage("gfx/bonus_super.png")
	editor.bonus.super.box = collider:addRectangle(232, 640, 38, 36)
	editor.bonus.super.box.type = "super"
	editor.bonus.slow = {}
	editor.bonus.slow.image = love.graphics.newImage("gfx/bonus_slow.png")
	editor.bonus.slow.box = collider:addRectangle(277, 640, 38, 36)
	editor.bonus.slow.box.type = "slow"
	editor.bonus.life = {}
	editor.bonus.life.image = love.graphics.newImage("gfx/bonus_life.png")
	editor.bonus.life.box = collider:addRectangle(322, 640, 38, 36)
	editor.bonus.life.box.type = "life"
	editor.bonus.multi = {}
	editor.bonus.multi.image = love.graphics.newImage("gfx/bonus_multi.png")
	editor.bonus.multi.box = collider:addRectangle(187, 685, 38, 36)
	editor.bonus.multi.box.type = "multi"
	editor.bonus.laser = {}
	editor.bonus.laser.image = love.graphics.newImage("gfx/bonus_laser.png")
	editor.bonus.laser.box = collider:addRectangle(232, 685, 38, 36)
	editor.bonus.laser.box.type = "laser"
	editor.bonus.large = {}
	editor.bonus.large.image = love.graphics.newImage("gfx/bonus_large.png")
	editor.bonus.large.box = collider:addRectangle(277, 685, 38, 36)
	editor.bonus.large.box.type = "large"
	editor.bonus.small = {}
	editor.bonus.small.image = love.graphics.newImage("gfx/bonus_small.png")
	editor.bonus.small.box = collider:addRectangle(322, 685, 38, 36)
	editor.bonus.small.box.type = "small"
	editor.bonus.currentImage = editor.bonus.glue.image
	editor.bonus.currentText = "C"
	-- Main menu variables ---------------------------------------------------------------------------
	editor.menu = {}
	editor.menu.button = love.graphics.newImage("gfx/menu_button.png")
	editor.menu.visible = false
	editor.menu.panel = love.graphics.newImage("gfx/menu.png")
	editor.menu.selected = love.graphics.newImage("gfx/cursor.png")
	editor.menu.box = collider:addRectangle(570, 720, 190, 49)
	editor.menu.box.type = "menu"
	editor.menu.buttonselected = love.graphics.newImage("gfx/menuselected.png")
	editor.load = collider:addRectangle(570, 585, 190, 33)
	editor.load.type = "load"
	editor.save = collider:addRectangle(570, 620, 190, 33)
	editor.save.type = "save"
	editor.reset = collider:addRectangle(570, 655, 190, 33)
	editor.reset.type = "reset"
	editor.help = collider:addRectangle(570, 690, 190, 33)
	editor.help.type = "help"
	editor.exit = collider:addRectangle(570, 725, 190, 33)
	editor.exit.type = "exit"
	-- Test button variables -----------------------------------------------------------------------
	editor.test = {}
	editor.test.start = collider:addRectangle(370, 720, 190, 49)
	editor.test.start.type = "test"
	editor.test.exit = false
	-- Extra dialog variables ----------------------------------------------------------------------
	editor.dialog = {}
	editor.dialog.panel = love.graphics.newImage("gfx/dialog_panel.png")
	editor.dialog.buttonDefault = love.graphics.newImage("gfx/dialog_default_button.png")
	editor.dialog.buttonSelected = love.graphics.newImage("gfx/dialog_selected_button.png")
	editor.dialog.yes = collider:addRectangle(290, 663, 90, 32)
	editor.dialog.yes.type = "yes"
	editor.dialog.no = collider:addRectangle(388, 663, 90, 32)
	editor.dialog.no.type = "no"
	editor.dialog.new = collider:addRectangle(591, 634, 90, 32)
	editor.dialog.new.type = "new"
	editor.dialog.exit = false
	editor.dialog.help = false
	editor.dialog.reset = false
	editor.dialog.save = false
	editor.dialog.load = false
	editor.dialog.nameInput = false
	editor.dialog.bigpanel = love.graphics.newImage("gfx/dialog_help.png")
	editor.dialog.filespanel = love.graphics.newImage("gfx/dialog_files.png")
	editor.dialog.arrowUpDefault = love.graphics.newImage("gfx/arrow_up_default.png")
	editor.dialog.arrowDownDefault = love.graphics.newImage("gfx/arrow_down_default.png")
	editor.dialog.arrowUpSelected = love.graphics.newImage("gfx/arrow_up_selected.png")
	editor.dialog.arrowDownSelected = love.graphics.newImage("gfx/arrow_down_selected.png")
	editor.dialog.slider = love.graphics.newImage("gfx/slider.png")
	editor.dialog.bar = {}
	editor.dialog.bar.top = love.graphics.newImage("gfx/bar_top.png")
	editor.dialog.bar.body = love.graphics.newImage("gfx/bar_body.png")
	editor.dialog.bar.bottom = love.graphics.newImage("gfx/bar_bottom.png")
	editor.dialog.bar.y = 620
	editor.dialog.bar.size = 0
	editor.dialog.bar.step = 0
	editor.dialog.bar.pos = 1
	editor.dialog.fileA = collider:addRectangle(92, 605, 234, 20)
	editor.dialog.fileA.type = "fileA"
	editor.dialog.fileB = collider:addRectangle(92, 626, 234, 20)
	editor.dialog.fileB.type = "fileB"
	editor.dialog.fileC = collider:addRectangle(92, 647, 234, 20)
	editor.dialog.fileC.type = "fileC"
	editor.dialog.fileD = collider:addRectangle(92, 668, 234, 20)
	editor.dialog.fileD.type = "fileD"
	editor.dialog.fileOver = love.graphics.newImage("gfx/file_over.png")
	editor.dialog.fileSelected = love.graphics.newImage("gfx/file_selected.png")
	editor.dialog.fileDisplay = {}
	editor.dialog.fileCount = 0
	editor.dialog.fileIndex = 1
	editor.dialog.fileUp = collider:addRectangle(330, 603, 28, 23)
	editor.dialog.fileUp.type = "fileUp"
	editor.dialog.fileUp.show = false
	editor.dialog.fileDown = collider:addRectangle(330, 675, 28, 23)
	editor.dialog.fileDown.type = "fileDown"
	editor.dialog.fileDown.show = false
	editor.dialog.levelCount = 0
	editor.dialog.levelIndex = 1
	editor.dialog.levelUp = collider:addRectangle(370, 603, 28, 23)
	editor.dialog.levelUp.type = "levelUp"
	editor.dialog.levelUp.show = false
	editor.dialog.levelDown = collider:addRectangle(370, 675, 28, 23)
	editor.dialog.levelDown.type = "levelDown"
	editor.dialog.levelDown.show = false
	editor.dialog.levelMax = 0
	editor.dialog.noSet = false
	editor.dialog.levelExists = false
	editor.dialog.input = love.graphics.newImage("gfx/text_input.png")
	editor.dialog.name = ""
	editor.dialog.popup = false
	editor.dialog.newSetMessage = "No set of levels seleted, you need to select one first."
	editor.dialog.typeMessage = "Type the name of the set."
	editor.dialog.empty = false
	editor.dialog.notEmpty = false
	editor.dialog.previewNew = love.graphics.newImage("gfx/preview_new.jpg")
	editor.dialog.previewLoad = love.graphics.newImage("gfx/preview_load.jpg")
	editor.dialog.previewMask = love.graphics.newImage("gfx/preview_mask.png")
	editor.dialog.preview = editor.dialog.previewLoad
	editor.dialog.over = nil
	editor.dialog.ox = 45
	editor.dialog.oy = 16
	editor.path = ""
	name = ""
	collider:addToGroup("buttons", editor.load, editor.save, editor.reset, editor.help, editor.exit, editor.dialog.yes, editor.dialog.no, editor.dialog.new, editor.bonus.box, editor.test.start, editor.bonus.glue.box, editor.bonus.super.box, editor.bonus.slow.box, editor.bonus.life.box, editor.bonus.multi.box, editor.bonus.laser.box, editor.bonus.large.box, editor.bonus.small.box, editor.dialog.fileUp, editor.dialog.fileDown, editor.dialog.levelUp, editor.dialog.levelDown)
	collider:setGhost(editor.blue, editor.green, editor.red, editor.yellow, editor.purple, editor.grey, editor.gold, editor.orange, editor.cyan, editor.white, editor.menu.box, editor.load, editor.save, editor.reset, editor.help, editor.exit, editor.dialog.yes, editor.dialog.new, editor.dialog.no, editor.bonus.box, editor.test.start, editor.bonus.glue.box, editor.bonus.super.box, editor.bonus.slow.box, editor.bonus.life.box, editor.bonus.multi.box, editor.bonus.laser.box, editor.bonus.large.box, editor.bonus.small.box, editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC, editor.dialog.fileD, editor.dialog.fileUp, editor.dialog.fileDown, editor.dialog.levelUp, editor.dialog.levelDown)
end
function Editor.update(dt)
	if editor.dialog.save == true then
		editor.dialog.levelMax = 1
	elseif editor.dialog.load == true then
		editor.dialog.levelMax = 0
	end
	if editor.dialog.fileIndex > 1 then
		editor.dialog.fileUp.show = true
	else
		editor.dialog.fileUp.show = false
	end
	if editor.dialog.fileCount > editor.dialog.fileIndex + 3 then
		editor.dialog.fileDown.show = true
	else
		editor.dialog.fileDown.show = false
	end
	if editor.dialog.levelIndex > 1 then
		editor.dialog.levelUp.show = true
	else
		editor.dialog.levelUp.show = false
	end
	if editor.dialog.levelIndex < editor.dialog.levelCount + editor.dialog.levelMax then
		editor.dialog.levelDown.show = true
	else
		editor.dialog.levelDown.show = false
	end
	if editor.dialog.fileCount > 4 then
		editor.dialog.bar.step = 50 / editor.dialog.fileCount
		editor.dialog.bar.size = 40 - editor.dialog.bar.step * (editor.dialog.fileCount - 4)
		if editor.dialog.bar.size < 1 then
			editor.dialog.bar.size = 1
		end
		editor.dialog.bar.y = 623 - editor.dialog.bar.step + (editor.dialog.bar.step * editor.dialog.fileIndex)
	end
	if editor.menu.visible == true then
		if editor.pointer == "load" then
			cursor.x = 562
			cursor.y = 588
		elseif editor.pointer == "save" then
			cursor.x = 562
			cursor.y = 623
		elseif editor.pointer == "reset" then
			cursor.x = 562
			cursor.y = 658
		elseif editor.pointer == "help" then
			cursor.x = 562
			cursor.y = 693
		elseif editor.pointer == "exit" then
			cursor.x = 562
			cursor.y = 728
		else
			cursor.x = -200
			cursor.y = -200
		end
	end
	pointer.point:moveTo(pointer.x, pointer.y)
	if pointer.y > 99 then
		if pointer.y < 576 then
			if pointer.x > 0 then
				if pointer.x < window.width - 1 then
					item.visible = true
				else
					item.visible = false
				end
			else
				item.visible = false
			end
		else
			item.visible = false
		end
	else
		item.visible = false
	end
	if item.visible == true then
		item.x = math.floor(pointer.x / 64) * 64
		item.y = math.floor(pointer.y / 32) * 32
	end
end
function Editor.draw()
	for i, v in ipairs(editor.grid) do
		love.graphics.draw(editor.cell, v.x, v.y)
	end
	for i, v in ipairs(bricks) do
		if v ~= 0 then
			love.graphics.draw(brick.shadow, v.x + 8, v.y + 8)
			if v.brick == "blue" then
				love.graphics.draw(brick.blue, v.x, v.y)
			elseif v.brick == "red" then
				love.graphics.draw(brick.red, v.x, v.y)
			elseif v.brick == "green" then
				love.graphics.draw(brick.green, v.x, v.y)
			elseif v.brick == "yellow" then
				love.graphics.draw(brick.yellow, v.x, v.y)
			elseif v.brick == "purple" then
				love.graphics.draw(brick.purple, v.x, v.y)
			elseif v.brick == "grey" then
				love.graphics.draw(brick.grey, v.x, v.y)
			elseif v.brick == "orange" then
				love.graphics.draw(brick.orange, v.x, v.y)
			elseif v.brick == "cyan" then
				love.graphics.draw(brick.cyan, v.x, v.y)
			elseif v.brick == "white" then
				love.graphics.draw(brick.white, v.x, v.y)
			elseif v.brick == "gold" then
				love.graphics.draw(brick.gold, v.x, v.y)
			end
			if v.bonus == "glue" then
				love.graphics.draw(editor.bonus.glue.image, v.x + 16, v.y + 2, 0, 0.65, 0.65)
				printbonus("C", v.x + 26, v.y + 13)
			elseif v.bonus == "super" then
				love.graphics.draw(editor.bonus.super.image, v.x + 16, v.y + 2, 0, 0.65, 0.65)
				printbonus("M", v.x + 26, v.y + 13)
			elseif v.bonus == "slow" then
				love.graphics.draw(editor.bonus.slow.image, v.x + 16, v.y + 2, 0, 0.65, 0.65)
				printbonus("S", v.x + 26, v.y + 13)
			elseif v.bonus == "life" then
				love.graphics.draw(editor.bonus.life.image, v.x + 16, v.y + 2, 0, 0.65, 0.65)
				printbonus("P", v.x + 26, v.y + 13)
			elseif v.bonus == "multi" then
				love.graphics.draw(editor.bonus.multi.image, v.x + 16, v.y + 2, 0, 0.65, 0.65)
				printbonus("D", v.x + 26, v.y + 13)
			elseif v.bonus == "laser" then
				love.graphics.draw(editor.bonus.laser.image, v.x + 16, v.y + 2, 0, 0.65, 0.65)
				printbonus("L", v.x + 26, v.y + 13)
			elseif v.bonus == "large" then
				love.graphics.draw(editor.bonus.large.image, v.x + 16, v.y + 2, 0, 0.65, 0.65)
				printbonus("E", v.x + 26, v.y + 13)
			elseif v.bonus == "small" then
				love.graphics.draw(editor.bonus.small.image, v.x + 16, v.y + 2, 0, 0.65, 0.65)
				printbonus("R", v.x + 26, v.y + 13)
			end
		end
	end
	love.graphics.draw(editor.bg, 0, 720)
	love.graphics.draw(editor.bonus.button.default, 250, 720)
	if editor.dialog.save == true then
		Editor.fileDialogDraw(602, 666, 634)
	elseif editor.dialog.load == true then
		Editor.fileDialogDraw(613, 656)
	end
	if editor.active ~= "nothing" then
		love.graphics.draw(editor.selected, editor.sx, editor.sy)
	end
	love.graphics.draw(editor.icon.blue, 8, 725)
	love.graphics.draw(editor.icon.green, 56, 725)
	love.graphics.draw(editor.icon.red, 104, 725)
	love.graphics.draw(editor.icon.purple, 152, 725)
	love.graphics.draw(editor.icon.grey, 200, 725)
	love.graphics.draw(editor.icon.yellow, 8, 748)
	love.graphics.draw(editor.icon.cyan, 56, 748)
	love.graphics.draw(editor.icon.white, 104, 748)
	love.graphics.draw(editor.icon.orange, 152, 748)
	love.graphics.draw(editor.icon.gold, 200, 748)
	if editor.bonus.visible == true then
		love.graphics.draw(editor.bonus.button.selected, 250, 720)
		love.graphics.draw(editor.bonus.panel, 173, 630)
		if editor.pointer ~= "nothing" then
			love.graphics.draw(editor.bonus.button.default, editor.bonus.x, editor.bonus.y, 0, 1, 1, 25, 24)
		end
		love.graphics.draw(editor.bonus.glue.image, 182, 635, 0, 0.8, 0.8, -6, -5)
		love.graphics.draw(editor.bonus.super.image, 227, 635, 0, 0.8, 0.8, -6, -5)
		love.graphics.draw(editor.bonus.slow.image, 272, 635, 0, 0.8, 0.8, -6, -5)
		love.graphics.draw(editor.bonus.life.image, 317, 635, 0, 0.8, 0.8, -6, -5)
		love.graphics.draw(editor.bonus.multi.image, 182, 680, 0, 0.8, 0.8, -6, -5)
		love.graphics.draw(editor.bonus.laser.image, 227, 680, 0, 0.8, 0.8, -6, -5)
		love.graphics.draw(editor.bonus.large.image, 272, 680, 0, 0.8, 0.8, -6, -5)
		love.graphics.draw(editor.bonus.small.image, 317, 680, 0, 0.8, 0.8, -6, -5)
		printbonus("C", 200, 653)
		printbonus("M", 244, 653)
		printbonus("S", 289, 653)
		printbonus("P", 335, 653)
		printbonus("D", 200, 698)
		printbonus("L", 244, 698)
		printbonus("E", 289, 698)
		printbonus("R", 335, 698)
	else
		love.graphics.draw(editor.bonus.currentImage, 250, 720, 0, 0.8, 0.8, -6, -5)
		printbonus(editor.bonus.currentText, 268, 738)
	end
	love.graphics.setFont(font.lives)
	love.graphics.draw(editor.menu.button, 570, 720)
	love.graphics.draw(editor.menu.button, 370, 720)
	if editor.menu.visible == true then
		love.graphics.draw(editor.menu.panel, 570, 582)
		love.graphics.draw(editor.menu.selected, cursor.x, cursor.y)
		love.graphics.setColor(128, 128, 128)
		love.graphics.printf("TRY", 370, 726, 190, "center")
		love.graphics.printf("Load", 570, 585, 190, "center")
		love.graphics.printf("Save", 570, 620, 190, "center")
		love.graphics.printf("Clear", 570, 655, 190, "center")
		love.graphics.printf("Help", 570, 690, 190, "center")
		love.graphics.printf("Exit", 570, 725, 190, "center")
		love.graphics.setColor(255, 255, 255)
	else
		love.graphics.setColor(128, 128, 128)
		love.graphics.printf("TRY", 370, 726, 190, "center")
		love.graphics.printf("MENU", 570, 726, 190, "center")
		love.graphics.setColor(255, 255, 255)
	end
	if item.visible == true then
		if editor.active ~= "nothing" then
			love.graphics.setColor(255, 255, 255, 192)
			love.graphics.draw(item.image, item.x, item.y, 0, item.scale, item.scale, item.ox, item.oy)
			if editor.active == "glue" or editor.active == "super" or editor.active == "slow" or editor.active == "life" or editor.active == "multi" or editor.active == "laser" or editor.active == "large" or editor.active == "small" then
				printbonus(editor.bonus.currentText, item.x + 26, item.y + 13)
			end
			love.graphics.setColor(255, 255, 255, 255)
		end
	end
	if editor.dialog.exit == true then
		Editor.drawPopup("There are unsaved changes, are you sure you want to quit?", "YES", "NO")
	elseif editor.dialog.help == true then
		love.graphics.draw(editor.dialog.bigpanel, 15, 600)
		love.graphics.draw(editor.dialog.buttonDefault, 339, 662)
		if editor.pointer == "yes" then
			love.graphics.draw(editor.dialog.buttonSelected, 339, 662)
		end
		love.graphics.setFont(font.dialog)
		love.graphics.setColor(128, 128, 128)
		love.graphics.print("To select an item click on it the bottom panel with the left mouse button.", 25, 605)
		love.graphics.print("The objects can only be placed on an existing brick on the canvas.", 25, 620)
		love.graphics.print("Use the right mouse button on the canvas to delete a brick.", 25, 635)
		love.graphics.print("OK", 374, 667)
	elseif editor.dialog.reset == true then
		love.graphics.draw(editor.dialog.panel, window.width / 2, 650, 0, 1, 1, 100, 50)
		love.graphics.draw(editor.dialog.buttonDefault, 291, 662)
		love.graphics.draw(editor.dialog.buttonDefault, 387, 662)
		if editor.pointer == "yes" then
			love.graphics.draw(editor.dialog.buttonSelected, 291, 662)
		elseif editor.pointer == "no" then
			love.graphics.draw(editor.dialog.buttonSelected, 387, 662)
		end
		love.graphics.setFont(font.dialog)
		love.graphics.setColor(128, 128, 128)
		love.graphics.printf("Do your really want to clear the canvas? This can't be undone.", 285, 600, 190, "center")
		love.graphics.print("YES", 320, 667)
		love.graphics.print("NO", 420, 667)
	elseif editor.dialog.empty == true then
		Editor.drawPopup("You can't save an empty level.", "OK")
	elseif editor.dialog.notEmpty == true then
		Editor.drawPopup("There is unsaved data, you will lose it.\nContinue?", "YES", "NO")
	end
	love.graphics.setColor(255, 0, 0)
	love.graphics.setColor(255, 255, 255)
end
function Editor.mousepressed(x, y, btn)
	if btn == "l" then
		if editor.menu.visible == true then
			if editor.pointer ~= "menu" then
				editor.menu.visible = false
				collider:setSolid(editor.menu.box)
				collider:setGhost(editor.load, editor.save, editor.reset, editor.help, editor.exit)
			end
		elseif editor.bonus.visible == true then
			if editor.pointer ~= "bonus" then
				editor.bonus.visible = false
				collider:setSolid(editor.bonus.box)
				collider:setGhost(editor.bonus.glue.box, editor.bonus.super.box, editor.bonus.slow.box, editor.bonus.life.box, editor.bonus.multi.box, editor.bonus.laser.box, editor.bonus.large.box, editor.bonus.small.box)
			end
		elseif editor.dialog.exit == true then
			if editor.pointer == "yes" then
				game.state = "title"
				collider:setSolid(button.start, button.edit, button.exit, button.load, button.options)
				collider:setGhost(editor.blue, editor.green, editor.red, editor.yellow, editor.purple, editor.grey, editor.orange, editor.cyan, editor.gold, editor.white, editor.menu.box, editor.bonus.box, editor.test.start, editor.dialog.yes, editor.dialog.no)
				editor.dialog.exit = false
			elseif editor.pointer == "no" or editor.pointer ~= "nothing" then
				editor.dialog.exit = false
				collider:setGhost(editor.dialog.yes, editor.dialog.no)
			end
		elseif editor.dialog.help == true then
			if editor.pointer ~= "nothing" then
				collider:setGhost(editor.dialog.yes)
				editor.dialog.help = false
			end
		elseif editor.dialog.reset == true then
			if editor.pointer == "yes" then
				collider:setGhost(editor.dialog.yes, editor.dialog.no)
				editor.dialog.reset = false
				bricks = {}
				for i = 1, 180 do
					table.insert(bricks, 0)
				end
				editor.changes = false
			elseif editor.pointer == "no" or editor.pointer ~= "nothing" then
				editor.dialog.reset = false
				collider:setGhost(editor.dialog.yes, editor.dialog.no)
			end
		elseif editor.dialog.save == true then
			Editor.fileDialogClicked("save")
		elseif editor.dialog.load == true then
			Editor.fileDialogClicked("load")
		elseif editor.dialog.empty == true then
			if editor.pointer ~= "nothing" then
				collider:setGhost(editor.dialog.yes)
				editor.dialog.empty = false
			end
		elseif editor.dialog.notEmpty == true then
			if editor.pointer == "yes" then
				editor.dialog.notEmpty = false
				editor.dialog.load = true
				editor.dialog.yes:moveTo(636, 629)
				editor.dialog.no:moveTo(636, 672)
				collider:setSolid(editor.dialog.fileUp, editor.dialog.fileDown, editor.dialog.levelUp, editor.dialog.levelDown)
				if editor.dialog.fileDisplay[4] ~= nil then
					collider:setSolid(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC, editor.dialog.fileD)
				elseif editor.dialog.fileDisplay[3] ~= nil then
					collider:setSolid(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC)
				elseif editor.dialog.fileDisplay[2] ~= nil then
					collider:setSolid(editor.dialog.fileA, editor.dialog.fileB)
				elseif editor.dialog.fileDisplay[1] ~= nil then
					collider:setSolid(editor.dialog.fileA)
				end
			elseif editor.pointer ~= "nothing" then
				collider:setGhost(editor.dialog.yes, editor.dialog.no)
				editor.dialog.notEmpty = false
			end
		end
		if editor.pointer == "menu" then
			collider:setGhost(editor.menu.box)
			collider:setSolid(editor.load, editor.save, editor.reset, editor.help, editor.exit)
			editor.active = "nothing"
			editor.selected = editor.menu.buttonselected
			cursor.x, cursor.y = editor.menu.box:center()
			cursor.x = cursor.x - 93
			cursor.y = cursor.y - 23
			editor.menu.visible = true
		elseif editor.pointer == "test" then
			if editor.menu.visible == true then
				collider:setGhost(editor.dialog.exit, editor.dialog.reset, editor.dialog.help, editor.dialog.load, editor.dialog.save)
			end
			Player.reset(300)
			game.state = "test"
			collider:setGhost(editor.blue, editor.green, editor.red, editor.yellow, editor.purple, editor.grey, editor.orange, editor.cyan, editor.gold, editor.white, editor.menu.box, editor.bonus.box, editor.test.start)
			collider:setSolid(wall.top, wall.left, wall.right, paddle.box)
			if love.filesystem.exists("temp.lua") == true then
				love.filesystem.remove("temp.lua")
			end
			table.save(bricks, "temp.lua")
			build()
			player.state = "normal"
		elseif editor.pointer == "exit" then
			editor.dialog.yes:moveTo(336, 678)
			editor.dialog.no:moveTo(433, 678)
			if editor.changes == true then
				editor.dialog.exit = true
				collider:setSolid(editor.dialog.yes, editor.dialog.no)
			else
				collider:setGhost(editor.blue, editor.green, editor.red, editor.yellow, editor.purple, editor.grey, editor.orange, editor.cyan, editor.gold, editor.white, editor.menu.box, editor.bonus.box, editor.test.start)
				collider:setSolid(button.start, button.edit, button.exit, button.load, button.options)
				game.state = "title"
			end
		elseif editor.pointer == "help" then
			editor.dialog.help = true
			collider:setSolid(editor.dialog.yes)
			editor.dialog.yes:moveTo(384, 678)
		elseif editor.pointer == "reset" then
			if Editor.testGrid() then
				editor.dialog.yes:moveTo(336, 678)
				editor.dialog.no:moveTo(433, 678)
				collider:setSolid(editor.dialog.yes, editor.dialog.no)
				editor.dialog.reset = true
			end
		elseif editor.pointer == "save" then
			Editor.getSets()
			if Editor.testGrid() then
				editor.dialog.save = true
				editor.dialog.preview = editor.dialog.previewLoad
				editor.dialog.yes:moveTo(636, 618)
				editor.dialog.no:moveTo(636, 684)
				collider:setSolid(editor.dialog.yes, editor.dialog.no, editor.dialog.new, editor.dialog.levelUp, editor.dialog.levelDown, editor.dialog.fileUp, editor.dialog.fileDown)
				if editor.dialog.fileDisplay[4] ~= nil then
					collider:setSolid(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC, editor.dialog.fileD)
				elseif editor.dialog.fileDisplay[3] ~= nil then
					collider:setSolid(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC)
				elseif editor.dialog.fileDisplay[2] ~= nil then
					collider:setSolid(editor.dialog.fileA, editor.dialog.fileB)
				elseif editor.dialog.fileDisplay[1] ~= nil then
					collider:setSolid(editor.dialog.fileA)
				end
			else
				editor.dialog.empty = true
				collider:setSolid(editor.dialog.yes)
				editor.dialog.yes:moveTo(384, 678)
			end
		elseif editor.pointer == "load" then
			editor.dialog.load = true
			Editor.getSets()
			editor.dialog.load = false
			if editor.changes == false then
				editor.dialog.load = true
				editor.dialog.preview = editor.dialog.previewLoad
				editor.dialog.yes:moveTo(636, 629)
				editor.dialog.no:moveTo(636, 672)
				collider:setSolid(editor.dialog.fileUp, editor.dialog.fileDown, editor.dialog.levelUp, editor.dialog.levelDown, editor.dialog.yes, editor.dialog.no)
				if editor.dialog.fileDisplay[4] ~= nil then
					collider:setSolid(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC, editor.dialog.fileD)
				elseif editor.dialog.fileDisplay[3] ~= nil then
					collider:setSolid(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC)
				elseif editor.dialog.fileDisplay[2] ~= nil then
					collider:setSolid(editor.dialog.fileA, editor.dialog.fileB)
				elseif editor.dialog.fileDisplay[1] ~= nil then
					collider:setSolid(editor.dialog.fileA)
				end
			else
				editor.dialog.notEmpty = true
				collider:setSolid(editor.dialog.yes, editor.dialog.no)
				editor.dialog.yes:moveTo(336, 678)
				editor.dialog.no:moveTo(433, 678)
			end
		elseif editor.pointer == "bonus" then
			editor.active = "nothing"
			editor.bonus.visible = true
			collider:setSolid(editor.bonus.glue.box, editor.bonus.super.box, editor.bonus.slow.box, editor.bonus.life.box, editor.bonus.multi.box, editor.bonus.laser.box, editor.bonus.large.box, editor.bonus.small.box)
			collider:setGhost(editor.bonus.box)
		elseif editor.pointer == "glue" then
			Editor.setBonus("glue", "C", editor.bonus.glue.image)
		elseif editor.pointer == "super" then
			Editor.setBonus("super", "M", editor.bonus.super.image)
		elseif editor.pointer == "slow" then
			Editor.setBonus("slow", "S", editor.bonus.slow.image)
		elseif editor.pointer == "life" then
			Editor.setBonus("life", "P", editor.bonus.life.image)
		elseif editor.pointer == "multi" then
			Editor.setBonus("multi", "D", editor.bonus.multi.image)
		elseif editor.pointer == "laser" then
			Editor.setBonus("laser", "L", editor.bonus.laser.image)
		elseif editor.pointer == "large" then
			Editor.setBonus("large", "E", editor.bonus.large.image)
		elseif editor.pointer == "small" then
			Editor.setBonus("small", "R", editor.bonus.small.image)
		elseif editor.pointer == "blue" then
			Editor.setBrick("blue")
		elseif editor.pointer == "green" then
			Editor.setBrick("green")
		elseif editor.pointer == "red" then
			Editor.setBrick("red")
		elseif editor.pointer == "yellow" then
			Editor.setBrick("yellow")
		elseif editor.pointer == "purple" then
			Editor.setBrick("purple")
		elseif editor.pointer == "grey" then
			Editor.setBrick("grey")
		elseif editor.pointer == "cyan" then
			Editor.setBrick("cyan")
		elseif editor.pointer == "orange" then
			Editor.setBrick("orange")
		elseif editor.pointer == "white" then
			Editor.setBrick("white")
		elseif editor.pointer == "gold" then
			Editor.setBrick("gold")
		elseif editor.pointer == "nothing" then
			if item.visible == true then
				if editor.active ~= "nothing" then
					if editor.dialog.load == false or editor.dialog.save == false then
						editor.changes = true
						local i = (item.x / 64) + (((item.y - 96) / 32) * 12) + 1
						if editor.active == "glue" or editor.active == "super" or editor.active == "slow" or editor.active == "life" or editor.active == "multi" or editor.active == "laser" or editor.active == "large" or editor.active == "small" then
							Editor.putElement(editor.active, item.X, item.y, i, editor.active)
						else
							Editor.putElement(editor.active, item.x, item.y, i, "nothing")
						end
					end
				end
			end
		end
	elseif btn == "r" then
		if item.visible == true then
			local i = (item.x / 64) + (((item.y - 96) / 32) * 12) + 1
			table.remove(bricks, i)
			table.insert(bricks, i, 0)
		end
	elseif btn == "wd" then
		if editor.active == "blue" then
			Editor.setBrick("green")
		elseif editor.active == "green" then
			Editor.setBrick("red")
		elseif editor.active == "red" then
			Editor.setBrick("purple")
		elseif editor.active == "purple" then
			Editor.setBrick("grey")
		elseif editor.active == "grey" then
			Editor.setBrick("yellow")
		elseif editor.active == "yellow" then
			Editor.setBrick("cyan")
		elseif editor.active == "cyan" then
			Editor.setBrick("white")
		elseif editor.active == "white" then
			Editor.setBrick("orange")
		elseif editor.active == "orange" then
			Editor.setBrick("gold")
		elseif editor.active == "gold" then
			Editor.setBrick("blue")
		elseif editor.active == "glue" then
			Editor.setBonus("super", "M", editor.bonus.super.image)
		elseif editor.active == "super" then
			Editor.setBonus("slow", "S", editor.bonus.slow.image)
		elseif editor.active == "slow" then
			Editor.setBonus("life", "P", editor.bonus.life.image)
		elseif editor.active == "life" then
			Editor.setBonus("multi", "D", editor.bonus.multi.image)
		elseif editor.active == "multi" then
			Editor.setBonus("laser", "L", editor.bonus.laser.image)
		elseif editor.active == "laser" then
			Editor.setBonus("large", "E", editor.bonus.large.image)
		elseif editor.active == "large" then
			Editor.setBonus("small", "R", editor.bonus.small.image)
		elseif editor.active == "small" then
			Editor.setBonus("glue", "C", editor.bonus.glue.image)
		end
	elseif btn == "wu" then
		if editor.active == "blue" then
			Editor.setBrick("gold")
		elseif editor.active == "green" then
			Editor.setBrick("blue")
		elseif editor.active == "red" then
			Editor.setBrick("green")
		elseif editor.active == "purple" then
			Editor.setBrick("red")
		elseif editor.active == "grey" then
			Editor.setBrick("purple")
		elseif editor.active == "yellow" then
			Editor.setBrick("grey")
		elseif editor.active == "cyan" then
			Editor.setBrick("yellow")
		elseif editor.active == "white" then
			Editor.setBrick("cyan")
		elseif editor.active == "orange" then
			Editor.setBrick("white")
		elseif editor.active == "gold" then
			Editor.setBrick("orange")
		elseif editor.active == "glue" then
			Editor.setBonus("small", "R", editor.bonus.small.image)
		elseif editor.active == "super" then
			Editor.setBonus("glue", "C", editor.bonus.glue.image)
		elseif editor.active == "slow" then
			Editor.setBonus("super", "M", editor.bonus.super.image)
		elseif editor.active == "life" then
			Editor.setBonus("slow", "S", editor.bonus.slow.image)
		elseif editor.active == "multi" then
			Editor.setBonus("life", "P", editor.bonus.life.image)
		elseif editor.active == "laser" then
			Editor.setBonus("multi", "D", editor.bonus.multi.image)
		elseif editor.active == "large" then
			Editor.setBonus("laser", "L", editor.bonus.laser.image)
		elseif editor.active == "small" then
			Editor.setBonus("large", "E", editor.bonus.large.image)
		end
	end
end
function Editor.setBrick(colour)
	editor.active = colour
	editor.selected = editor.brickSelected
	if colour == "blue" then
		editor.sx, editor.sy = editor.blue:center()
		item.image = brick.blue
	elseif colour == "green" then
		editor.sx, editor.sy = editor.green:center()
		item.image = brick.green
	elseif colour == "red" then
		editor.sx, editor.sy = editor.red:center()
		item.image = brick.red
	elseif colour == "yellow" then
		editor.sx, editor.sy = editor.yellow:center()
		item.image = brick.yellow
	elseif colour == "purple" then
		editor.sx, editor.sy = editor.purple:center()
		item.image = brick.purple
	elseif colour == "grey" then
		editor.sx, editor.sy = editor.grey:center()
		item.image = brick.grey
	elseif colour == "cyan" then
		editor.sx, editor.sy = editor.cyan:center()
		item.image = brick.cyan
	elseif colour == "orange" then
		editor.sx, editor.sy = editor.orange:center()
		item.image = brick.orange
	elseif colour == "white" then
		editor.sx, editor.sy = editor.white:center()
		item.image = brick.white
	elseif colour == "gold" then
		editor.sx, editor.sy = editor.gold:center()
		item.image = brick.gold
	end
	editor.sx = editor.sx - 19
	editor.sy = editor.sy - 11
	item.ox = 0
	item.oy = 0
	item.scale = 1
end
function Editor.setBonus(text, initial, image)
	editor.active = text
	editor.selected = editor.bonus.button.selected
	editor.sx= 250
	editor.sy = 720
	item.image = image
	item.ox = -25
	item.oy = -3
	item.scale = 0.65
	editor.bonus.currentText = initial
	editor.bonus.currentImage = image
end
function Editor.getLevels(name)
	local index = 0
	if love.filesystem.exists(name) == true then
		local levels = love.filesystem.getDirectoryItems(name)
		for i, v in ipairs(levels) do
			if love.filesystem.isFile(name.."/"..v) == true then
				local l = string.len(v) - 3
				local ext = string.sub(v, l, l + 3)
				if ext == ".lua" then
					index = index + 1
				end
			end
		end
	end
	if index > 0 then
		editor.dialog.preview = love.graphics.newImage(name.."/level1.jpg")
	else
		editor.dialog.preview = editor.dialog.previewNew
	end
	return index
end
function Editor.getSets()
	editor.sets = {}
	editor.dialog.fileCount = 0
	editor.dialog.levelCount = 0
	editor.dialog.fileIndex = 1
	editor.dialog.levelIndex = 1
	editor.dialog.fileDisplay = {}
	local path = love.filesystem.getSaveDirectory()
	path = path.."/levels"
	if love.filesystem.exists(path) == false then
		love.filesystem.createDirectory("levels")
	end
	local sets = love.filesystem.getDirectoryItems("levels")
	local index = 0
	for i, v in ipairs(sets) do
		if love.filesystem.isDirectory("levels/"..v) == true then
			if editor.dialog.load == true or menu.load == true then
				local content = love.filesystem.getDirectoryItems("levels/"..v)
				local isEmpty = true
				for j, w in ipairs(content) do
					if w ~= nil then
						isEmpty = false
					end
				end
				if isEmpty == false then
					table.insert(editor.sets, v)
					index = index + 1
				end
			else
				table.insert(editor.sets, v)
				index = index + 1
			end
		end
	end
	editor.dialog.fileCount = index
	if game.state == "editor" then
		for i, v in ipairs(editor.sets) do
			table.insert(editor.dialog.fileDisplay, v)
			if v == 4 then
				break
			end
		end
	elseif game.state == "title" then
		table.insert(menu.levels, "Default")
		for i, v in ipairs(editor.sets) do
			table.insert(menu.levels, v)
			if v == 11 then
				break
			end
		end
	end
	if editor.dialog.fileCount == 0 then
		editor.dialog.newSetMessage = "There are no set of levels, you new to create a new one first."
	else
		editor.dialog.newSetMessage = "No set of levels seleted, you need to select one first."
	end
end
function Editor.moveList(direction)
	local limit = 0
	if game.state == "title" then
		limit = 10
	else
		limit = 3
	end
	if direction == "up" then
		editor.dialog.fileIndex = editor.dialog.fileIndex - 1
		if editor.dialog.fileIndex < 1 then
			editor.dialog.fileIndex = 1
		end
	elseif direction == "down" then
		editor.dialog.fileIndex = editor.dialog.fileIndex + 1
		if editor.dialog.fileIndex + limit > editor.dialog.fileCount then
			editor.dialog.fileIndex = editor.dialog.fileCount - limit
		end
	end
	if game.state == "editor" then
		editor.dialog.fileDisplay = {}
	elseif game.state == "title" then
		menu.levels = {}
		table.insert(menu.levels, "Default")
	end
	for i = editor.dialog.fileIndex, editor.dialog.fileIndex + limit do
		if game.state == "editor" then
			table.insert(editor.dialog.fileDisplay, editor.sets[i])
		elseif game.state == "title" then
			table.insert(menu.levels, editor.sets[i])
		end
	end
	if editor.active ~= "nothing" then
		editor.active = "nothing"
	end
end
function Editor.moveLevel(value)
	local overflow = false
	editor.dialog.levelIndex = editor.dialog.levelIndex + value
	if editor.dialog.levelIndex < 1 then
		editor.dialog.levelIndex = 1
	elseif editor.dialog.levelIndex > editor.dialog.levelCount then
		if editor.dialog.save == true then
			editor.dialog.levelIndex = editor.dialog.levelCount + 1
			overflow = true
		elseif editor.dialog.load == true then
			editor.dialog.levelIndex = editor.dialog.levelCount
		end
	end
	if editor.dialog.levelCount == 0 then
		editor.dialog.levelIndex = 1
	end
	if overflow == false then
		editor.dialog.preview = love.graphics.newImage(editor.path.."/level"..editor.dialog.levelIndex..".jpg")
	else 
		editor.dialog.preview = editor.dialog.previewNew
	end
end
function Editor.drawPopup(text, yes, no)
	love.graphics.draw(editor.dialog.panel, window.width / 2, 650, 0, 1, 1, 100, 50)
	love.graphics.setFont(font.dialog)
	if no == nil then
		love.graphics.draw(editor.dialog.buttonDefault, 339, 662)
		if editor.pointer == "yes" then
			love.graphics.draw(editor.dialog.buttonSelected, 339, 662)
		end
		love.graphics.setFont(font.dialog)
		love.graphics.setColor(128, 128, 128)
		love.graphics.printf(text, 288, 600, 190, "center")
		love.graphics.printf(yes, 339, 667, 90, "center")
	else
		love.graphics.draw(editor.dialog.buttonDefault, 291, 662)
		love.graphics.draw(editor.dialog.buttonDefault, 387, 662)
		if editor.pointer == "yes" then
			love.graphics.draw(editor.dialog.buttonSelected, 291, 662)
		elseif editor.pointer == "no" then
			love.graphics.draw(editor.dialog.buttonSelected, 387, 662)
		end
		love.graphics.setColor(128, 128, 128)
		love.graphics.printf(text, 288, 600, 190, "center")
		love.graphics.printf(yes, 291, 667, 90, "center")
		love.graphics.printf(no, 387, 667, 90, "center")
	end
	love.graphics.setColor(255, 255, 255)
end
function Editor.newSet(name)
	if love.filesystem.exists("levels/"..name) == false then
		love.filesystem.createDirectory("levels/"..name)
		editor.dialog.fileCount = editor.dialog.fileCount + 1
		editor.dialog.name = ""
		editor.dialog.nameInput = false
		table.insert(editor.sets, name)
		editor.dialog.fileDisplay = {}
		for i = editor.dialog.fileIndex, editor.dialog.fileIndex + 3 do
			table.insert(editor.dialog.fileDisplay, editor.sets[i])
		end
		editor.dialog.no:moveTo(636, 684)
		editor.dialog.popup = false
		editor.dialog.nameInput = false
		collider:setSolid(editor.blue, editor.green, editor.red, editor.yellow, editor.purple, editor.grey, editor.gold, editor.orange, editor.cyan, editor.white, editor.menu.box, editor.dialog.new, editor.bonus.box, editor.test.start, editor.dialog.levelUp, editor.dialog.levelDown, editor.dialog.fileUp, editor.dialog.fileDown)
		editor.dialog.yes:moveTo(636, 618)
		if editor.dialog.fileDisplay[4] ~= nil then
			collider:setSolid(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC, editor.dialog.fileD)
		elseif editor.dialog.fileDisplay[3] ~= nil then
			collider:setSolid(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC)
		elseif editor.dialog.fileDisplay[2] ~= nil then
			collider:setSolid(editor.dialog.fileA, editor.dialog.fileB)
		elseif editor.dialog.fileDisplay[1] ~= nil then
			collider:setSolid(editor.dialog.fileA)
		end
		Editor.getSets()
	else
		editor.dialog.typeMessage = "Name already exists."
	end
end
function Editor.keypressed(key)
	if editor.dialog.nameInput == true then
		if editor.dialog.typeMessage == "Name already exists." then
			editor.dialog.typeMessage = "Type the name of the set."
		end
		local l = string.len(editor.dialog.name)
		for _, v in pairs(editor.characters, key) do
			if v == key then
				if l < 12 then
					editor.dialog.name = editor.dialog.name..key
				end
			end
		end
		if key == "backspace" then
			editor.dialog.name = string.sub(editor.dialog.name, 1, l-1)
		elseif key == "return" then
			if l > 0 then
				Editor.newSet(editor.dialog.name)
			end
		end
	else

	end
end
function Editor.testLevel(name)
	if love.filesystem.exists(name) == true then
		editor.dialog.popup = true
		editor.dialog.levelExists = true
		editor.active = "nothing"
		collider:setGhost(editor.blue, editor.green, editor.red, editor.yellow, editor.purple, editor.grey, editor.gold, editor.orange, editor.cyan, editor.white)
		if editor.dialog.save == true then
			collider:setGhost(editor.dialog.new)
		end
		collider:setGhost(editor.menu.box, editor.bonus.box, editor.test.start, editor.dialog.levelUp, editor.dialog.levelDown, editor.dialog.fileUp, editor.dialog.fileDown)
		if editor.dialog.fileDisplay[4] ~= nil then
			collider:setGhost(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC, editor.dialog.fileD)
		elseif editor.dialog.fileDisplay[3] ~= nil then
			collider:setGhost(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC)
		elseif editor.dialog.fileDisplay[2] ~= nil then
			collider:setGhost(editor.dialog.fileA, editor.dialog.fileB)
		elseif editor.dialog.fileDisplay[1] ~= nil then
			collider:setGhost(editor.dialog.fileA)
		end
		editor.dialog.yes:moveTo(336, 678)
		editor.dialog.no:moveTo(433, 678)
	else
		Editor.saveLevel(name)
	end
end
function Editor.saveLevel(name)
	if editor.dialog.popup == true then
		love.filesystem.remove(name)
		collider:setGhost(editor.dialog.yes, editor.dialog.no)
		collider:setSolid(editor.blue, editor.green, editor.red, editor.yellow, editor.purple, editor.grey, editor.gold, editor.orange, editor.cyan, editor.white, editor.menu.box, editor.bonus.box, editor.test.start)
	else
		collider:setGhost(editor.dialog.yes, editor.dialog.no, editor.dialog.new, editor.dialog.fileUp, editor.dialog.fileDown, editor.dialog.levelUp, editor.dialog.levelDown)
		if editor.dialog.fileDisplay[4] ~= nil then
			collider:setGhost(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC, editor.dialog.fileD)
		elseif editor.dialog.fileDisplay[3] ~= nil then
			collider:setGhost(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC)
		elseif editor.dialog.fileDisplay[2] ~= nil then
			collider:setGhost(editor.dialog.fileA, editor.dialog.fileB)
		elseif editor.dialog.fileDisplay[1] ~= nil then
			collider:setGhost(editor.dialog.fileA)
		end
	end
	table.save(bricks, name)
	editor.dialog.save = false
	editor.active = "nothing"
	local l = string.len(name) - (9 + string.len(tostring(editor.dialog.levelIndex)))
	local folder = string.sub(name, 1, l)
	local image = love.graphics.newScreenshot()
	local imageFile = folder.."level"..editor.dialog.levelIndex..".jpg"
	if love.filesystem.exists(imageFile) == true then
		love.filesystem.remove(imageFile)
	end
	image:encode(imageFile, "jpg")
	editor.changes = false
	editor.dialog.levelCount = 0
	editor.dialog.levelIndex = 1
end
function Editor.testGrid()
	local index = 0
	for i, v in ipairs(bricks) do
		if v ~= 0 then
			index = index + 1
		end
	end
	if index > 0 then
		return true
	else
		return false
	end
end
function Editor.putElement(colour, x, y, index, pow)
	if pow == "nothing" then
		local t = {}
		t.brick = colour
		t.x = x
		t.y = y
		t.value = 10
		if colour == "white" then
			t.value = 50
		elseif colour == "orange" then
			t.value = 60
		elseif colour == "cyan" then
			t.value = 70
		elseif colour == "green" then
			t.value = 80
		elseif colour == "red" then
			t.value = 90
		elseif colour == "blue" then
			t.value = 100
		elseif colour == "purple" then
			t.value = 110
		elseif colour == "yellow" then
			t.value = 120
		elseif colour == "grey" then
			t.value = level * 50
		end
		t.bonus = pow
		table.remove(bricks, index)
		table.insert(bricks, index, t)
	else
		if bricks[index] ~= 0 then
			bricks[index].bonus = pow
		end
	end
end
function Editor.fileDialogDraw(yes, no, new)
	love.graphics.draw(editor.dialog.filespanel, 84, 600)
	love.graphics.draw(editor.bonus.button.default, 360, 625)
	if editor.dialog.fileCount > 4 then
		love.graphics.draw(editor.dialog.slider, 330, 620)
		love.graphics.draw(editor.dialog.bar.top, 332, editor.dialog.bar.y)
		love.graphics.draw(editor.dialog.bar.body, 332, editor.dialog.bar.y + 5, 0, 1, editor.dialog.bar.size)
		love.graphics.draw(editor.dialog.bar.bottom, 332, editor.dialog.bar.y + 5 + editor.dialog.bar.size)
		if editor.dialog.fileUp.show == true then
			love.graphics.draw(editor.dialog.arrowUpDefault, 330, 603)
		end
		if editor.dialog.fileDown.show == true then
			love.graphics.draw(editor.dialog.arrowDownDefault, 330, 675)
		end
	end
	if editor.dialog.levelUp.show == true then
		love.graphics.draw(editor.dialog.arrowUpDefault, 370, 603)
	end
	if editor.dialog.levelDown.show == true then
		love.graphics.draw(editor.dialog.arrowDownDefault, 370, 675)
	end
	love.graphics.draw(editor.dialog.buttonDefault, 591, yes)
	love.graphics.draw(editor.dialog.buttonDefault, 591, no)
	if new ~= nil then
		love.graphics.draw(editor.dialog.buttonDefault, 591, new)
	end
	if editor.dialog.over ~= nil then
		if editor.pointer == "fileDown" then
			if editor.dialog.fileDown.show == true then
				love.graphics.draw(editor.dialog.over, cursor.x, cursor.y, 0, 1, 1, editor.dialog.ox, editor.dialog.oy)
			end
		elseif editor.pointer == "fileUp" then
			if editor.dialog.fileUp.show == true then
				love.graphics.draw(editor.dialog.over, cursor.x, cursor.y, 0, 1, 1, editor.dialog.ox, editor.dialog.oy)
			end
		elseif editor.pointer == "levelDown" then
			if editor.dialog.levelDown.show == true then
				love.graphics.draw(editor.dialog.over, cursor.x, cursor.y, 0, 1, 1, editor.dialog.ox, editor.dialog.oy)
			end
		elseif editor.pointer == "levelUp" then
			if editor.dialog.levelUp.show == true then
				love.graphics.draw(editor.dialog.over, cursor.x, cursor.y, 0, 1, 1, editor.dialog.ox, editor.dialog.oy)
			end
		else
 			love.graphics.draw(editor.dialog.over, cursor.x, cursor.y, 0, 1, 1, editor.dialog.ox, editor.dialog.oy)
 		end
	end
	love.graphics.draw(editor.dialog.preview, 418, 615, 0, 0.1, 0.1)
	love.graphics.draw(editor.dialog.previewMask, 410, 607)	
	love.graphics.setFont(font.dialog)
	love.graphics.setColor(128, 128, 128)
	if editor.sets[1] ~= nil then
		love.graphics.print(editor.dialog.fileDisplay[1], 100, 607)
	end
	if editor.sets[2] ~= nil then
		love.graphics.print(editor.dialog.fileDisplay[2], 100, 627)
	end
	if editor.sets[3] ~= nil then
		love.graphics.print(editor.dialog.fileDisplay[3], 100, 647)
	end
	if editor.sets[4] ~= nil then
		love.graphics.print(editor.dialog.fileDisplay[4], 100, 667)
	end
	
	love.graphics.printf("OK", 591, yes + 2, 90, "center")
	love.graphics.printf("CANCEL", 591, no + 2, 90, "center")
	if new ~= nil then
		love.graphics.printf("NEW", 591, new + 2, 90, "center")
	end
	love.graphics.printf(editor.dialog.levelIndex, 360, 637, 49, "center")
	love.graphics.setColor(255, 255, 255)
	if new ~= nil then
		if editor.dialog.noSet == true then
			Editor.drawPopup(editor.dialog.newSetMessage, "OK")
		elseif editor.dialog.nameInput == true then
			Editor.drawPopup(editor.dialog.typeMessage, "OK", "CANCEL")
			love.graphics.draw(editor.dialog.input, 289, 625)
			love.graphics.setColor(128, 128, 128)
			love.graphics.printf(editor.dialog.name, 292, 629, 190, "center")
			love.graphics.setColor(255, 255, 255)
		elseif editor.dialog.levelExists == true then
			Editor.drawPopup("A level already exists at this index, do you want to overwrite it?", "YES", "NO")
		end
	end
end
function Editor.fileDialogClicked(mode)
	if editor.pointer == "fileA" then
		editor.active = "fileA"
		editor.sx = 90
		editor.sy = 603
		editor.selected = editor.dialog.fileSelected
		editor.path = "levels/"..editor.dialog.fileDisplay[1]
		editor.dialog.levelCount = Editor.getLevels(editor.path)
		editor.dialog.levelIndex = 1
	elseif editor.pointer == "fileB" then
		editor.active = "fileB"
		editor.sx = 90
		editor.sy = 624
		editor.selected = editor.dialog.fileSelected
		editor.path = "levels/"..editor.dialog.fileDisplay[2]
		editor.dialog.levelCount = Editor.getLevels(editor.path)
		editor.dialog.levelIndex = 1
	elseif editor.pointer == "fileC" then
		editor.active = "fileC"
		editor.sx = 90
		editor.sy = 643
		editor.selected = editor.dialog.fileSelected
		editor.path = "levels/"..editor.dialog.fileDisplay[3]
		editor.dialog.levelCount = Editor.getLevels(editor.path)
		editor.dialog.levelIndex = 1
	elseif editor.pointer == "fileD" then
		editor.active = "fileD"
		editor.sx = 90
		editor.sy = 662
		editor.selected = editor.dialog.fileSelected
		editor.path = "levels/"..editor.dialog.fileDisplay[4]
		editor.dialog.levelCount = Editor.getLevels(editor.path)
		editor.dialog.levelIndex = 1
	elseif editor.pointer == "fileUp" then
		Editor.moveList("up")
	elseif editor.pointer == "fileDown" then
		Editor.moveList("down")
	elseif editor.pointer == "levelUp" then
		Editor.moveLevel(-1)
	elseif editor.pointer == "levelDown" then
		Editor.moveLevel(1)
	elseif editor.pointer == "yes" then
		editor.selected = editor.dialog.buttonSelected
		if mode == "load" then
			local name = ""
		end
		if editor.dialog.popup == false then
			if editor.active == "fileA" then
				name = "levels/"..editor.dialog.fileDisplay[1].."/level"..editor.dialog.levelIndex..".lua"
				Editor.testLevel(name, false)
				if mode == "load" then
					Editor.fileLoad()
				end
			elseif editor.active == "fileB" then
				name = "levels/"..editor.dialog.fileDisplay[2].."/level"..editor.dialog.levelIndex..".lua"
				Editor.testLevel(name, false)
				if mode == "load" then
					Editor.fileLoad()
				end
			elseif editor.active == "fileC" then
				name = "levels/"..editor.dialog.fileDisplay[3].."/level"..editor.dialog.levelIndex..".lua"
				Editor.testLevel(name, false)
				if mode == "load" then
					Editor.fileLoad()
				end
			elseif editor.active == "fileD" then
				name = "levels/"..editor.dialog.fileDisplay[4].."/level"..editor.dialog.levelIndex..".lua"
				Editor.testLevel(name, false)
				if mode == "load" then
					Editor.fileLoad()
				end
			else
				editor.dialog.popup = true
				collider:setGhost(editor.blue, editor.green, editor.red, editor.yellow, editor.purple, editor.grey, editor.gold, editor.orange, editor.cyan, editor.white, editor.menu.box, editor.dialog.new, editor.bonus.box, editor.test.start, editor.dialog.levelUp, editor.dialog.levelDown, editor.dialog.fileUp, editor.dialog.fileDown)
				if editor.sets[4] ~= nil then
					collider:setGhost(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC, editor.dialog.fileD)
				elseif editor.sets[3] ~= nil then
					collider:setGhost(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC)
				elseif editor.sets[2] ~= nil then
					collider:setGhost(editor.dialog.fileA, editor.dialog.fileB)
				elseif editor.sets[1] ~= nil then
					collider:setGhost(editor.dialog.fileA)
				end
				if editor.dialog.noSet == false then
					collider:setGhost(editor.dialog.no)
					editor.dialog.noSet = true
					editor.dialog.yes:moveTo(384, 678)
				end
			end
		else
			local l = string.len(editor.dialog.name)
			if editor.dialog.nameInput == true then
				if l > 0 then
					Editor.newSet(editor.dialog.name)
				end
			elseif editor.dialog.noSet == true then
				collider:setSolid(editor.dialog.no, editor.dialog.levelUp, editor.dialog.levelDown, editor.dialog.fileUp, editor.dialog.fileDown)
				editor.dialog.popup = false
				editor.dialog.noSet = false
				collider:setSolid(editor.blue, editor.green, editor.red, editor.yellow, editor.purple, editor.grey, editor.gold, editor.orange, editor.cyan, editor.white, editor.menu.box, editor.dialog.new, editor.bonus.box, editor.test.start)
				editor.dialog.yes:moveTo(636, 618)
				if editor.sets[4] ~= nil then
					collider:setSolid(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC, editor.dialog.fileD)
				elseif editor.sets[3] ~= nil then
					collider:setSolid(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC)
				elseif editor.sets[2] ~= nil then
					collider:setSolid(editor.dialog.fileA, editor.dialog.fileB)
				elseif editor.sets[1] ~= nil then
					collider:setSolid(editor.dialog.fileA)
				end
			elseif editor.dialog.levelExists == true then
				Editor.saveLevel(name)
				editor.dialog.levelExists = false
				editor.dialog.popup = false
			end
		end
	elseif editor.pointer == "no" then
		editor.selected = editor.dialog.buttonSelected
		if mode == "save" then
			if editor.dialog.popup == false then
				editor.dialog.levelIndex = 1
				editor.dialog.fileIndex = 1
				editor.dialog.fileDisplay = {}
				for i = editor.dialog.fileIndex, editor.dialog.fileIndex + 3 do
					table.insert(editor.dialog.fileDisplay, editor.sets[i])
				end
				collider:setGhost(editor.dialog.yes, editor.dialog.no, editor.dialog.new, editor.dialog.levelUp, editor.dialog.levelDown, editor.dialog.fileUp, editor.dialog.fileDown)
				editor.active = "nothing"
				editor.dialog.save = false
				if editor.sets[4] ~= nil then
					collider:setGhost(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC, editor.dialog.fileD)
				elseif editor.sets[3] ~= nil then
					collider:setGhost(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC)
				elseif editor.sets[2] ~= nil then
					collider:setGhost(editor.dialog.fileA, editor.dialog.fileB)
				elseif editor.sets[1] ~= nil then
					collider:setGhost(editor.dialog.fileA)
				end
				editor.sets = {}
			else
				if editor.dialog.nameInput == true then
					editor.dialog.typeMessage = "Type the name of the set."
					editor.dialog.name = ""
					editor.dialog.nameInput = false
				elseif editor.dialog.levelExists == true then
					editor.dialog.levelExists = false
				end
				collider:setSolid(editor.blue, editor.green, editor.red, editor.yellow, editor.purple, editor.grey, editor.gold, editor.orange, editor.cyan, editor.white, editor.menu.box, editor.bonus.box, editor.test.start, editor.dialog.new, editor.dialog.bonus, editor.dialog.new)
				collider:setSolid(editor.dialog.levelUp, editor.dialog.levelDown, editor.dialog.fileUp, editor.dialog.fileDown)
				if editor.sets[4] ~= nil then
					collider:setSolid(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC, editor.dialog.fileD)
				elseif editor.sets[3] ~= nil then
					collider:setSolid(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC)
				elseif editor.sets[2] ~= nil then
					collider:setSolid(editor.dialog.fileA, editor.dialog.fileB)
				elseif editor.sets[1] ~= nil then
					collider:setSolid(editor.dialog.fileA)
				end
				editor.dialog.yes:moveTo(636, 618)
				editor.dialog.no:moveTo(636, 684)
				editor.dialog.popup = false
			end
		elseif mode == "load" then
			editor.active = "nothing"
			editor.dialog.load = false
			collider:setGhost(editor.dialog.fileUp, editor.dialog.fileDown, editor.dialog.levelUp, editor.dialog.levelDown, editor.dialog.yes, editor.dialog.no)
			if editor.dialog.fileDisplay[4] ~= nil then
				collider:setGhost(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC, editor.dialog.fileD)
			elseif editor.dialog.fileDisplay[3] ~= nil then
				collider:setGhost(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC)
			elseif editor.dialog.fileDisplay[2] ~= nil then
				collider:setGhost(editor.dialog.fileA, editor.dialog.fileB)
			elseif editor.dialog.fileDisplay[1] ~= nil then
				collider:setGhost(editor.dialog.fileA)
			end
		end
	elseif editor.pointer == "new" then
		editor.selected = editor.dialog.buttonSelected
		cursor.x, cursor.y = editor.dialog.new:center()
		cursor.x = cursor.x - 45
		cursor.y = cursor.y - 16
		editor.active = "nothing"
		editor.dialog.popup = true
		editor.dialog.nameInput = true
		collider:setGhost(editor.blue, editor.green, editor.red, editor.yellow, editor.purple, editor.grey, editor.gold, editor.orange, editor.cyan, editor.white, editor.menu.box, editor.bonus.box, editor.test.start, editor.dialog.new, editor.dialog.levelUp, editor.dialog.levelDown, editor.dialog.fileUp, editor.dialog.fileDown)
		editor.dialog.yes:moveTo(336, 678)
		editor.dialog.no:moveTo(433, 678)
		if editor.sets[4] ~= nil then
			collider:setGhost(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC, editor.dialog.fileD)
		elseif editor.sets[3] ~= nil then
			collider:setGhost(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC)
		elseif editor.sets[2] ~= nil then
			collider:setGhost(editor.dialog.fileA, editor.dialog.fileB)
		elseif editor.sets[1] ~= nil then
			collider:setGhost(editor.dialog.fileA)
		end
	elseif editor.pointer ~= "nothing" then
		if mode == "load" then
			editor.active = "nothing"
			editor.dialog.load = false
			collider:setGhost(editor.dialog.fileUp, editor.dialog.fileDown, editor.dialog.levelUp, editor.dialog.levelDown, editor.dialog.yes, editor.dialog.no)
			if editor.dialog.fileDisplay[4] ~= nil then
				collider:setGhost(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC, editor.dialog.fileD)
			elseif editor.dialog.fileDisplay[3] ~= nil then
				collider:setGhost(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC)
			elseif editor.dialog.fileDisplay[2] ~= nil then
				collider:setGhost(editor.dialog.fileA, editor.dialog.fileB)
			elseif editor.dialog.fileDisplay[1] ~= nil then
				collider:setGhost(editor.dialog.fileA)
			end
		end
	else
		if mode == "save" then
			if editor.dialog.nameInput == false then
				editor.active = "nothing"
				editor.dialog.save = false
				collider:setGhost(editor.dialog.fileUp, editor.dialog.fileDown, editor.dialog.levelUp, editor.dialog.levelDown, editor.dialog.yes, editor.dialog.no, editor.dialog.new)
				if editor.dialog.fileDisplay[4] ~= nil then
					collider:setGhost(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC, editor.dialog.fileD)
				elseif editor.dialog.fileDisplay[3] ~= nil then
					collider:setGhost(editor.dialog.fileA, editor.dialog.fileB, editor.dialog.fileC)
				elseif editor.dialog.fileDisplay[2] ~= nil then
					collider:setGhost(editor.dialog.fileA, editor.dialog.fileB)
				elseif editor.dialog.fileDisplay[1] ~= nil then
					collider:setGhost(editor.dialog.fileA)
				end
			end
		end
	end
end
function Editor.fileLoad()
	bricks = table.load(name)
	editor.dialog.load = false
	collider:setGhost(editor.dialog.yes, editor.dialog.no)
	collider:setSolid(editor.blue, editor.green, editor.red, editor.yellow, editor.purple, editor.grey, editor.orange, editor.cyan, editor.gold, editor.white, editor.menu.box, editor.bonus.box, editor.test.start)
	editor.dialog.popup = false
	editor.changes = true
	editor.dialog.levelExists = false
end
function Editor.setOver(object)
	editor.bonus.x, editor.bonus.y = object:center()
	cursor.x, cursor.y = object:center()
	if object.type == "yes" or object.type == "no" then
		editor.dialog.over = editor.dialog.buttonSelected
		editor.dialog.ox = 45
		editor.dialog.oy = 16
	elseif object.type == "fileUp" then
		if editor.dialog.fileUp.show == true then
			editor.dialog.over = editor.dialog.arrowUpSelected
			editor.dialog.ox = 14
			editor.dialog.oy = 12
		end
	elseif object.type == "fileDown" then
		if editor.dialog.fileDown.show == true then
			editor.dialog.over = editor.dialog.arrowDownSelected
			editor.dialog.ox = 14
			editor.dialog.oy = 12
		end
	elseif object.type == "levelUp" then
		if editor.dialog.levelUp.show == true then
			editor.dialog.over = editor.dialog.arrowUpSelected
			editor.dialog.ox = 14
			editor.dialog.oy = 12
		end
	elseif object.type == "levelDown" then
		if editor.dialog.levelDown.show == true then
			editor.dialog.over = editor.dialog.arrowDownSelected
			editor.dialog.ox = 14
			editor.dialog.oy = 12
		end
	elseif object.type == "fileA" or object.type == "fileB" or object.type == "fileC" or object.type == "fileD"then
		editor.dialog.over = editor.dialog.fileOver
		editor.dialog.ox = 119
		editor.dialog.oy = 12
	else
		editor.dialog.over = nil
	end
end
function Test.update(dt)
	if pointer.x > 678 then
		if pointer.y < 49 then
			editor.test.exit = true
		else
			editor.test.exit = false
		end
	else
		editor.test.exit = false
	end
	Game.updateField(dt)
	Player.update(dt)
end
function Test.draw()
	Game.drawField()
	Player.draw()
	love.graphics.draw(editor.dialog.buttonDefault, 678, 0)
	if editor.test.exit == true then
		love.graphics.draw(editor.dialog.buttonSelected, 678, 0)
	end
	love.graphics.setFont(font.dialog)
	love.graphics.setColor(128, 128, 128)
	love.graphics.printf("EXIT", 678, 5, 90, "center")
	love.graphics.setColor(255, 255, 255)
end
function Test.mousepressed(x, y, btn)
	if editor.test.exit == false then
		if btn == "l" then
			for i, v in ipairs(balls) do
				v.box.lock = false
			end
			if paddle.mode == "laser" then
				Player.shoot(paddle.x, paddle.y)
			end
		end
	else
		Game.cleanScreen(true)
		bricks = table.load("temp.lua")
		love.filesystem.remove("temp.lua")
		game.state = "editor"
		Player.reset(300)
		collider:setSolid(editor.blue, editor.green, editor.red, editor.yellow, editor.purple, editor.grey, editor.orange, editor.cyan, editor.gold, editor.white, editor.menu.box, editor.bonus.box, editor.test.start)
		collider:setGhost(wall.top, wall.left, wall.right, paddle.box)
	end
end