Menu = {}
GameOver = {}
Congrats = {}
Score = {}
Debug = {}
function Menu.load()
	congrats = {}
	congrats.timer = 0
	congrats.alpha = 0
	congrats.bonus = 0
	congrats.noContinue = false
	congrats.oneLife = false
	congrats.lives = false
	congrats.grandSlam = false
	congrats.bonusNC = 0
	congrats.bonusL = 0
	congrats.bonusOL = 0
	congrats.bonusGS = 0
	congrats.final = false
	congrats.x = 0
	congrats.operation = false
	congrats.steps = {false, false, false, false, false, false}
	menu = {}
	menu.video = {}
	menu.video.modes = love.window.getFullscreenModes(1)
	table.sort(menu.video.modes, function(a, b) return a.width*a.height < b.width*b.height end)
	menu.video.index = 1
	menu.options = {}
	menu.options.show = false
	menu.options.fs = window.fs
	menu.options.bulletEmpty = love.graphics.newImage("gfx/bullet_empty.png")
	menu.options.bulletOver = love.graphics.newImage("gfx/bullet_over.png")
	menu.options.bullet = love.graphics.newImage("gfx/bullet.png")
	menu.options.easy = collider:addCircle(429, 379, 9)
	menu.options.easy.type = "easy"
	menu.options.normal = collider:addCircle(429, 399, 9)
	menu.options.normal.type = "normal"
	menu.options.hard = collider:addCircle(429, 419, 9)
	menu.options.hard.type = "hard"
	menu.options.fullscreen = collider:addCircle(429, 469, 9)
	menu.options.fullscreen.type = "fullscreen"
	menu.options.windowed = collider:addCircle(429, 489, 9)
	menu.options.windowed.type = "windowed"
	collider:setGhost(menu.options.easy, menu.options.normal, menu.options.hard)
	menu.options.difficulty = game.difficulty
	menu.alpha = 255
	menu.levels = {}
	local y = 320
	menu.folders = {}
	for i = 1, 12 do
		y = y + 20
		local box = collider:addRectangle(285, y , 168, 20)
		box.type = "file"..i
		box.exists = false
		collider:addToGroup("button", box)
		collider:setGhost(box)
		table.insert(menu.folders, box)
	end
	menu.load = false
	menu.dialog = {}
	menu.dialog.panel = love.graphics.newImage("gfx/load_panel.png")
	menu.dialog.yes = collider:addRectangle(292, 580, 90, 32)
	menu.dialog.yes.type = "yes"
	menu.dialog.no = collider:addRectangle(388, 580, 90, 32)
	menu.dialog.no.type = "no"
	menu.dialog.slider = love.graphics.newImage("gfx/slider_big.png")
	menu.dialog.x = 0
	menu.dialog.y = 0
	menu.dialog.ox = 0
	menu.dialog.oy = 0
	menu.dialog.sx = 282
	menu.dialog.sy = 0
	menu.dialog.fileOver_small = love.graphics.newImage("gfx/file_over_small.png")
	menu.dialog.fileOver_large = love.graphics.newImage("gfx/file_over_mid.png")
	menu.dialog.fileOver = menu.dialog.fileOver_large
	menu.dialog.fileSelected_small = love.graphics.newImage("gfx/file_selected_small.png")
	menu.dialog.fileSelected_large = love.graphics.newImage("gfx/file_selected_mid.png")
	menu.dialog.fileSelected = menu.dialog.fileSelected_large
	menu.dialog.over = menu.dialog.fileOver
	menu.dialog.fileUp = collider:addRectangle(457, 343, 28, 23)
	menu.dialog.fileUp.type = "fileUp"
	menu.dialog.fileUp.exists = false
	menu.dialog.fileDown = collider:addRectangle(457, 560, 28, 23)
	menu.dialog.fileDown.type = "fileDown"
	menu.dialog.fileDown.exists = false
	menu.dialog.selected = false
	menu.pointer = "nothing"
	menu.yes = collider:addRectangle(290, 399, 90, 32)
	menu.yes.type = "yes"
	menu.no = collider:addRectangle(384, 399, 90, 32)
	menu.no.type = "no"
	button = {default = {}, selected = {}}
	button.default.image = love.graphics.newImage("gfx/buttonDefault.png")
	button.default.ox = button.default.image:getWidth() / 2
	button.default.oy = button.default.image:getHeight() / 2
	button.selected.image = love.graphics.newImage("gfx/buttonSelected.png")
	button.selected.ox = button.selected.image:getWidth() / 2
	button.selected.oy = button.selected.image:getHeight() / 2
	button.start = collider:addRectangle(384 - button.default.ox, 365 - button.default.oy, button.default.ox * 2, button.default.oy * 2)
	button.start.type = "start"
	button.edit = collider:addRectangle(384 - button.default.ox, 479 - button.default.oy, button.default.ox * 2, button.default.oy * 2)
	button.edit.type = "edit"
	button.load = collider:addRectangle(384 - button.default.ox, 422 - button.default.oy, button.default.ox * 2, button.default.oy * 2)
	button.load.type = "load"
	button.options = collider:addRectangle(384 - button.default.ox, 536 - button.default.oy, button.default.ox * 2, button.default.oy * 2)
	button.options.type = "options"
	button.exit = collider:addRectangle(384 - button.default.ox, 593 - button.default.oy, button.default.ox * 2, button.default.oy * 2)
	button.exit.type = "exit"
	collider:addToGroup("button", button.start, button.edit, button.load, button.options, button.exit, menu.dialog.fileUp, menu.dialog.fileDown)
	collider:setGhost(menu.dialog.yes, menu.dialog.no, menu.yes, menu.no, menu.dialog.fileUp, menu.dialog.fileDown)
	continue = {}
	continue.fade = 0.01
	continue.alpha = 255
	continue.color = 255
	continue.pointer = "nothing"
	continue.timer = 9.99
	continue.yes = collider:addRectangle(128, 650, 190, 49)
	continue.yes.type = "yes"
	continue.no = collider:addRectangle(448, 650, 190, 49)
	continue.no.type = "no"
	continue.button = {}
	continue.button.default = love.graphics.newImage("gfx/continue_default.png")
	continue.button.yes = love.graphics.newImage("gfx/continue_yes.png")
	continue.button.no = love.graphics.newImage("gfx/continue_no.png")
	collider:setGhost(continue.yes, continue.no)
	scores = {}
	scores.name = ""
	scores.length = 0
	scores.input = false
	scores.best = {}
	scores.worst = {}
	scores.type = "nothing"
	scores.index = 0
	scores.timer = 0
	scores.panel = love.graphics.newImage("gfx/name_input.png")
	title = {}
	title.logo = love.graphics.newImage("gfx/logo.png")
	title.panel = love.graphics.newImage("gfx/score_panel.png")
	if love.filesystem.exists("scores_best.lua") then
		scores.best = table.load("scores_best.lua")
	else
		scores.best[1] = {name="Yannick", value=190000, level=10, complete="no"}
		scores.best[2] = {name="Yannick", value=180000, level=9, complete="no"}
		scores.best[3] = {name="Yannick", value=170000, level=8, complete="no"}
		scores.best[4] = {name="Yannick", value=160000, level=7, complete="no"}
		scores.best[5] = {name="Yannick", value=150000, level=6, complete="no"}
		scores.best[6] = {name="Yannick", value=140000, level=5, complete="no"}
		scores.best[7] = {name="Yannick", value=130000, level=4, complete="no"}
		scores.best[8] = {name="Yannick", value=120000, level=3, complete="no"}
		scores.best[9] = {name="Yannick", value=110000, level=2, complete="no"}
		scores.best[10] = {name="Yannick", value=100000, level=1, complete="no"}
		table.save(scores.best, "scores_best.lua")
	end
	if love.filesystem.exists("scores_worst.lua") then
		scores.worst = table.load("scores_worst.lua")
	else
		scores.worst[1] = {name="Yannick", value=9955, level=1, complete="no"}
		scores.worst[2] = {name="Yannick", value=9960, level=1, complete="no"}
		scores.worst[3] = {name="Yannick", value=9965, level=1, complete="no"}
		scores.worst[4] = {name="Yannick", value=9970, level=1, complete="no"}
		scores.worst[5] = {name="Yannick", value=9975, level=1, complete="no"}
		scores.worst[6] = {name="Yannick", value=9980, level=1, complete="no"}
		scores.worst[7] = {name="Yannick", value=9985, level=1, complete="no"}
		scores.worst[8] = {name="Yannick", value=9990, level=1, complete="no"}
		scores.worst[9] = {name="Yannick", value=9995, level=1, complete="no"}
		scores.worst[10] = {name="Yannick", value=10000, level=1, complete="no"}
		table.save(scores.worst, "scores_worst.lua")
	end
end
function Menu.update(dt)
	if menu.alpha < 255 then
		menu.alpha = menu.alpha - dt * 800
		if menu.alpha < 0 then
			menu.alpha = 255
			love.mouse.setVisible(false)
			love.mouse.setGrabbed(true)
			game.state = "game"
			Player.reset(300)
			levelload(level)
			ball.image = ball.normal
			paddle.mode = "normal"
			paddle.image = paddle.normal
			collider:setGhost(button.start, button.edit, button.exit, button.load, button.options, pointer.point)
			collider:setSolid(paddle.box, wall.left, wall.top, wall.right)
			if game.difficulty == "easy" then
				player.lives = 5
				ball.speed = 5
				ball.limit = 5
				ball.step = 7
			elseif game.difficulty == "normal" then
				player.lives = 3
				ball.speed = 7
				ball.limit = 7
				ball.step = 6
			elseif game.difficulty == "hard" then
				player.lives = 1
				ball.speed = 9
				ball.limit = 9
				ball.step = 4
			end
		end
	else
		bling:update(dt)
		if editor.dialog.fileCount > 11 then
			menu.dialog.fileOver = menu.dialog.fileOver_small
			menu.dialog.fileSelected = menu.dialog.fileSelected_small
		else
			menu.dialog.fileOver = menu.dialog.fileOver_large
			menu.dialog.fileSelected = menu.dialog.fileSelected_large
		end
		if editor.dialog.fileCount > 11 then
			editor.dialog.bar.step = 188 / editor.dialog.fileCount
			editor.dialog.bar.size = 178 - editor.dialog.bar.step * (editor.dialog.fileCount - 12)
			if editor.dialog.bar.size < 1 then
				editor.dialog.bar.size = 1
			end
			editor.dialog.bar.y = 366 - editor.dialog.bar.step + (editor.dialog.bar.step * editor.dialog.fileIndex)
		end
	end
end
function Menu.draw()
	love.graphics.setColor(255, 255, 255, menu.alpha)
	love.graphics.draw(bling, 400, 170)
	love.graphics.draw(title.logo, 32, 62)
	love.graphics.draw(title.panel, 20, 340)
	love.graphics.draw(title.panel, 500, 340)
	love.graphics.setFont(font.dialog)
	love.graphics.setColor(128, 128, 128, menu.alpha)
	love.graphics.printf("hall of Fame", 20, 345, 248, "center")
	love.graphics.printf("hall of Shame", 500, 345, 248, "center")
	local y = 365
	for i, v in ipairs(scores.best) do
		love.graphics.print(v.name, 25, y)
		love.graphics.print(v.value, 170, y)
		if v.complete == "yes" then
			love.graphics.draw(stars.image, 250, y + 4)
		else
			love.graphics.printf(v.level, 250, y, 10, "center")
		end
		y = y + 25
	end
	y = 365
	for i, v in ipairs(scores.worst) do
		love.graphics.print(v.name, 505, y)
		love.graphics.print(v.value, 650, y)
		if v.complete == "yes" then
			love.graphics.draw(stars.image, 730, y + 4)
		else
			love.graphics.printf(v.level, 730, y, 10, "center")
		end
		y = y + 25
	end
	love.graphics.setColor(255, 255, 255, menu.alpha)
	love.graphics.draw(button.default.image, window.width / 2, 365, 0, 1, 1, button.default.ox, button.default.oy)
	love.graphics.draw(button.default.image, 384, 422, 0, 1, 1, button.default.ox, button.default.oy)
	love.graphics.draw(button.default.image, 384, 479, 0, 1, 1, button.default.ox, button.default.oy)
	love.graphics.draw(button.default.image, 384, 536, 0, 1, 1, button.default.ox, button.default.oy)
	love.graphics.draw(button.default.image, 384, 593, 0, 1, 1, button.default.ox, button.default.oy)
	if pointer.over == "start" then
		love.graphics.draw(button.selected.image, 384,365, 0, 1, 1, button.default.ox, button.default.oy)
	elseif pointer.over == "load" then
		love.graphics.draw(button.selected.image, 384, 422, 0, 1, 1, button.default.ox, button.default.oy)
	elseif pointer.over == "edit" then
		love.graphics.draw(button.selected.image, 384, 479, 0, 1, 1, button.default.ox, button.default.oy)
	elseif pointer.over == "options" then
		love.graphics.draw(button.selected.image, 384, 536, 0, 1, 1, button.default.ox, button.default.oy)
	elseif pointer.over == "exit" then
		love.graphics.draw(button.selected.image, 384, 593, 0, 1, 1, button.default.ox, button.default.oy)
	end
	love.graphics.setColor(128, 128, 128, menu.alpha)
	love.graphics.setFont(font.lives)
	love.graphics.printf("START", 0, 345, window.width, "center")
	love.graphics.printf("LOAD", 0, 402, window.width, "center")
	love.graphics.printf("EDIT", 0, 459, window.width, "center")
	love.graphics.printf("OPTIONS", 0, 516, window.width, "center")
	love.graphics.printf("QUIT", 0, 573, window.width, "center")
	love.graphics.setColor(255, 255, 255, menu.alpha)
	if menu.load == true then
		love.graphics.draw(menu.dialog.panel, 279, 340)
		love.graphics.draw(editor.dialog.buttonDefault, 292, 584)
		love.graphics.draw(editor.dialog.buttonDefault, 388, 584)
		if editor.dialog.fileCount > 11 then
			love.graphics.draw(menu.dialog.slider, 457, 364)
			love.graphics.draw(editor.dialog.bar.top, 459, editor.dialog.bar.y)
			love.graphics.draw(editor.dialog.bar.body, 459, editor.dialog.bar.y + 5, 0, 1, editor.dialog.bar.size)
			love.graphics.draw(editor.dialog.bar.bottom, 459, editor.dialog.bar.y + 5 + editor.dialog.bar.size)
			if editor.dialog.fileIndex > 1 then
				love.graphics.draw(editor.dialog.arrowUpDefault, 457, 343)
			end
			if editor.dialog.fileCount - editor.dialog.fileIndex > 11 then
				love.graphics.draw(editor.dialog.arrowDownDefault, 457, 560)
			end
		end
		if pointer.over ~= "nothing" then
			love.graphics.draw(menu.dialog.over, menu.dialog.x, menu.dialog.y, 0, 1, 1, menu.dialog.ox, menu.dialog.oy)
		end
		love.graphics.setColor(128, 128, 128, menu.alpha)
		love.graphics.setFont(font.dialog)
		for i, v in ipairs(menu.folders) do
			if v.exists == true then
				local x, y = v:center()
				love.graphics.print(menu.levels[i], x - 84, y - 10)
			end
		end
		love.graphics.printf("OK", 292, 585, 100, "center")
		love.graphics.printf("CANCEL", 388, 585, 100, "center")
		love.graphics.setColor(255, 255, 255, menu.alpha)
		if menu.dialog.selected == true then
			love.graphics.draw(menu.dialog.fileSelected, menu.dialog.sx, menu.dialog.sy)
		end
	else
		if game.custom == true then
			love.graphics.draw(game.customIcon, 455, 328)
		end
	end
	if menu.options.show == true then
		love.graphics.draw(menu.dialog.panel, 279, 340)
		love.graphics.draw(editor.dialog.buttonDefault, 292, 584)
		love.graphics.draw(editor.dialog.buttonDefault, 388, 584)
		love.graphics.draw(menu.options.bulletEmpty, 420, 370)
		love.graphics.draw(menu.options.bulletEmpty, 420, 390)
		love.graphics.draw(menu.options.bulletEmpty, 420, 410)
		love.graphics.draw(menu.options.bulletEmpty, 420, 460)
		love.graphics.draw(menu.options.bulletEmpty, 420, 480)
		if pointer.over ~= "nothing" then
			love.graphics.draw(menu.dialog.over, menu.dialog.x, menu.dialog.y, 0, 1, 1, menu.dialog.ox, menu.dialog.oy)
		end
		if menu.options.difficulty == "easy" then
			love.graphics.draw(menu.options.bullet, 424, 374)
		elseif menu.options.difficulty == "normal" then
			love.graphics.draw(menu.options.bullet, 424, 394)
		elseif menu.options.difficulty == "hard" then
			love.graphics.draw(menu.options.bullet, 424, 414)
		end
		if menu.options.fs == true then
			love.graphics.draw(menu.options.bullet, 424, 464)
		else
			love.graphics.draw(menu.options.bullet, 424, 484)
		end
		love.graphics.setColor(128, 128, 128, menu.alpha)
		love.graphics.setFont(font.dialog)
		love.graphics.printf("DIFFICULTY", 0, 345, 768, "center")
		love.graphics.printf("VIDEO", 0, 440, 768, "center")
		love.graphics.print("FULLSCREEN", 330, 460)
		love.graphics.print("WINDOWED", 330, 480)
		love.graphics.print("EASY", 330, 370)
		love.graphics.print("NORMAL", 330, 390)
		love.graphics.print("HARD", 330, 410)
		love.graphics.printf("OK", 292, 585, 100, "center")
		love.graphics.printf("CANCEL", 388, 585, 100, "center")
		love.graphics.setColor(255, 255, 255, menu.alpha)
	end
end
function Menu.keypressed(key)
	if key == "escape" then
		love.event.quit()
	end
end
function Menu.mousepressed(x, y, btn)
	if btn == "l" then
		if pointer.over == "start" then
			menu.alpha = 254.9
		elseif pointer.over == "edit" then
			game.state = "editor"
			bricks = {}
			for i = 1, 180 do
				table.insert(bricks, 0)
			end
			collider:setGhost(button.start, button.edit, button.exit, button.load, button.options)
			collider:setSolid(editor.blue, editor.green, editor.red, editor.yellow, editor.purple, editor.grey, editor.cyan, editor.white, editor.gold, editor.orange, editor.menu.box, editor.bonus.box, editor.test.start)
		elseif pointer.over == "exit" then
			love.event.quit()
		elseif pointer.over == "load" then
			TEsound.play("sfx/click.ogg")
			menu.load = true
			collider:setGhost(button.start, button.edit, button.exit, button.load, button.options)
			collider:setSolid(menu.dialog.yes, menu.dialog.no)
			Editor.getSets()
			for i, v in ipairs(menu.levels) do
				menu.folders[i].exists = true
				if i == 12 then
					break
				end
			end
			for i, v in pairs(menu.folders) do
				if v.exists == true then
					collider:setSolid(v)
				end
			end
			if editor.dialog.fileCount > 11 then
				collider:setSolid(menu.dialog.fileDown)
				menu.dialog.fileDown.exists = true
			end
		elseif pointer.over == "options" then
			collider:setGhost(button.start, button.edit, button.exit, button.load, button.options)
			collider:setSolid(menu.dialog.yes, menu.dialog.no, menu.options.easy, menu.options.normal, menu.options.hard)
			TEsound.play("sfx/click.ogg")
			menu.options.show = true
		elseif pointer.over == "file1" then
			Menu.selectPack(340)
		elseif pointer.over == "file2" then
			Menu.selectPack(360, 2)
		elseif pointer.over == "file3" then
			Menu.selectPack(380, 3)
		elseif pointer.over == "file4" then
			Menu.selectPack(400, 4)
		elseif pointer.over == "file5" then
			Menu.selectPack(420, 5)
		elseif pointer.over == "file6" then
			Menu.selectPack(440, 6)
		elseif pointer.over == "file7" then
			Menu.selectPack(460, 7)
		elseif pointer.over == "file8" then
			Menu.selectPack(480, 8)
		elseif pointer.over == "file9" then
			Menu.selectPack(500, 9)
		elseif pointer.over == "file10" then
			Menu.selectPack(520, 10)
		elseif pointer.over == "file11" then
			Menu.selectPack(540, 11)
		elseif pointer.over == "file12" then
			Menu.selectPack(560, 12)
		elseif pointer.over == "yes" then
			if menu.load == true then
				if menu.dialog.selected == true then
					TEsound.play("sfx/click.ogg")
					menu.dialog.selected = false
					for i, v in pairs(menu.folders) do
						if v.exists == true then
							collider:setGhost(v)
						end
					end
					collider:setSolid(button.start, button.edit, button.exit, button.load, button.options)
					collider:setGhost(menu.dialog.yes, menu.dialog.no)
					if menu.dialog.fileUp.exists == true then
						collider:setGhost(menu.dialog.fileUp)
					elseif menu.dialog.fileDown.exists == true then
						collider:setGhost(menu.dialog.fileDown)
					end
					menu.levels = {}
					menu.load = false
				end
			end
			if menu.options.show == true then
				game.difficulty = menu.options.difficulty
				TEsound.play("sfx/click.ogg")
				collider:setSolid(button.start, button.edit, button.exit, button.load, button.options)
				collider:setGhost(menu.dialog.yes, menu.dialog.no)
				collider:setGhost(menu.options.easy, menu.options.normal, menu.options.hard)
				menu.options.show = false
			end
		elseif pointer.over == "no" then
			TEsound.play("sfx/click.ogg")
			if menu.load == true then
				game.custom = false
				menu.dialog.selected = false
				for i, v in pairs(menu.folders) do
					if v.exists == true then
						collider:setGhost(v)
					end
				end
				collider:setSolid(button.start, button.edit, button.exit, button.load, button.options)
				collider:setGhost(menu.dialog.yes, menu.dialog.no)
				if menu.dialog.fileUp.exists == true then
					collider:setGhost(menu.dialog.fileUp)
				elseif menu.dialog.fileDown.exists == true then
					collider:setGhost(menu.dialog.fileDown)
				end
				menu.levels = {}
				menu.load = false
			end
			if menu.options.show == true then
				menu.options.show = false
				collider:setSolid(button.start, button.edit, button.exit, button.load, button.options)
				collider:setGhost(menu.dialog.yes, menu.dialog.no, menu.options.easy, menu.options.normal, menu.options.hard)
			end
		elseif pointer.over == "fileUp" then
			TEsound.play("sfx/click.ogg")
			menu.dialog.selected = false
			Editor.moveList("up")
			if editor.dialog.fileIndex == 1 then
				collider:setGhost(menu.dialog.fileUp)
				collider:setSolid(menu.dialog.fileDown)
				menu.dialog.fileUp.exists = false
				menu.dialog.fileDown.exists = true
			end
		elseif pointer.over == "fileDown" then
			TEsound.play("sfx/click.ogg")
			menu.dialog.selected = false
			Editor.moveList("down")
			if editor.dialog.fileCount - editor.dialog.fileIndex < 12 then
				collider:setGhost(menu.dialog.fileDown)
				collider:setSolid(menu.dialog.fileUp)
				menu.dialog.fileUp.exists = true
				menu.dialog.fileDown.exists = false
			end
		elseif pointer.over == "easy" or pointer.over == "normal" or pointer.over == "hard" then
			menu.options.difficulty = pointer.over
		end
	end
end
function Menu.setOver(object)
	editor.bonus.x, editor.bonus.y = object:center()
	if object.type == "yes" then
		menu.dialog.over = editor.dialog.buttonSelected
		menu.dialog.ox = 45
		menu.dialog.oy = 12
	elseif object.type == "no" then
		menu.dialog.over = editor.dialog.buttonSelected
		menu.dialog.ox = 45
		menu.dialog.oy = 12
	elseif object.type == "fileUp" then
		menu.dialog.over = editor.dialog.arrowUpSelected
		menu.dialog.ox = 14
		menu.dialog.oy = 12
	elseif object.type == "fileDown" then
		menu.dialog.over = editor.dialog.arrowDownSelected
		menu.dialog.ox = 14
		menu.dialog.oy = 12
	elseif object.type == "easy" or object.type == "normal" or object.type == "hard" or object.type == "fullscreen" or object.type == "windowed" then
		menu.dialog.over = menu.options.bulletOver
		menu.dialog.ox = 9
		menu.dialog.oy = 9
	else
		menu.dialog.over = menu.dialog.fileOver
		menu.dialog.ox = 88
		menu.dialog.oy = 10
	end
end
function GameOver.update(dt)
	continue.timer = continue.timer - dt
	continue.fade = continue.fade + dt
	continue.alpha = continue.alpha - dt * 300
	continue.color = continue.color - (1 / continue.timer * dt * 900)
	if continue.color < 0 then
		continue.color = 0
	end
	if continue.alpha < 0 then
		continue.alpha = 0

	end
	pointer.point:moveTo(pointer.x, pointer.y)
	if continue.timer < -0.5 then
		collider:setGhost(continue.yes, continue.no, pointer.point)
		Game.checkScore()
	end
	if continue.fade > 1 then
		if continue.timer > 0 then 
			TEsound.play("sfx/countdown.ogg")
			continue.fade = 0
			continue.alpha = 255
			continue.color = 255
		else
			continue.alpha = 255
			continue.color = 0
		end
	end
end
function GameOver.draw()
	love.graphics.setFont(font.normal)
	prints("GAME OVER", 0, 200, 8, 8, window.width, "center")
	prints("CONTINUE?", 0, 368, 8, 8, 768, "center")
	love.graphics.setColor(0, 0, 0, continue.alpha / 2)
	love.graphics.printf(math.floor(continue.timer) + 1, 8, 526, 768, "center")
	love.graphics.setColor(255, continue.color, continue.color, continue.alpha)
	love.graphics.printf(math.floor(continue.timer) + 1, 0, 518, 768, "center")
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.draw(continue.button.default, 128, 650)
	love.graphics.draw(continue.button.default, 448, 650)
	love.graphics.setFont(font.lives)
	love.graphics.setColor(128, 128, 128)
	love.graphics.printf("YES", 128, 656, 190, "center")
	love.graphics.printf("NO", 448, 656, 190, "center")
	love.graphics.setColor(255, 255, 255)
	if continue.pointer == "yes" then
		love.graphics.setColor(255, 255, 255)
		love.graphics.draw(continue.button.yes, 128, 650)
		love.graphics.printf("YES", 128, 656, 190, "center")
	elseif continue.pointer == "no" then
		love.graphics.setColor(255, 255, 255)
		love.graphics.draw(continue.button.no, 448, 650)
		love.graphics.printf("NO", 448, 656, 190, "center")
	end
end
function GameOver.keypressed(key)
	game.state = "title"
end
function GameOver.mousepressed(x, y, btn)
	if btn == "l" then
		if continue.pointer == "yes" then
			collider:setGhost(continue.yes, continue.no, pointer.point)
			Player.reset(300)
			player.score = 0
			player.perfect = true
			player.continue = true
			Game.reset("game")
			love.mouse.setVisible(false)
			love.mouse.setGrabbed(true)
			levelload(level)
		elseif continue.pointer == "no" then
			collider:setGhost(continue.yes, continue.no, pointer.point)
			Game.checkScore()
		end
	end
end
function Congrats.update(dt)
	if congrats.alpha < 255 then
		congrats.alpha = congrats.alpha + dt * 700
		if congrats.alpha > 255 then
			congrats.alpha = 255
			if game.difficulty == "easy" then
				congrats.bonusNC = 20000
				congrats.bonusL = 2000
				congrats.bonusOL = 50000
				congrats.bonusGS = 100000
			elseif game.difficulty == "normal" then
				congrats.bonusNC = 50000
				congrats.bonusL = 5000
				congrats.bonusOL = 150000
				congrats.bonusGS = 200000
			elseif game.difficulty == "hard" then
				congrats.bonusNC = 100000
				congrats.bonusL = 10000
				congrats.bonusOL = 500000
				congrats.bonusGS = 1000000
			end
			congrats.x = 300 - font.normal:getWidth(congrats.bonusL) / 2
		end
	else
		congrats.timer = congrats.timer + dt
		if player.lives > 0 then
			congrats.steps[1] = true
			congrats.lives = true
			if congrats.timer > 1 then
				congrats.timer = 0.5
				congrats.bonus = congrats.bonus + congrats.bonusL
				player.lives = player.lives - 1
				TEsound.play("sfx/bonus.ogg")
			end
		else
			if congrats.steps[1] == false then
				if congrats.timer < 1.5 then
					congrats.timer = 1.5
					congrats.steps[1] = true
				end
			end
		end
		if congrats.timer > 1.5 then
			congrats.lives = false
		end
		if player.continue == false then
			congrats.steps[2] = true
			if congrats.timer > 2 then
				TEsound.play("sfx/element.ogg")
				player.continue = true
				congrats.noContinue = true
			end
		else
			if congrats.steps[1] == true and congrats.steps[2] == false then
				if congrats.timer < 3 then
					congrats.timer = 3
					congrats.steps[2] = true
				end
			end
		end
		if congrats.timer > 3 then
			if congrats.noContinue == true then
				congrats.bonus = congrats.bonus + congrats.bonusNC
				congrats.noContinue = false
			end
		end
		if player.oneLife == true then
			congrats.steps[3] = true
			if congrats.timer > 3.5 then
				player.oneLife = false
				TEsound.play("sfx/element.ogg")
				congrats.oneLife = true
			end
		else
			if congrats.steps[1] == true and congrats.steps[2] == true and congrats.steps[3] == false then
				if congrats.timer < 4.5 then
					congrats.timer = 4.5
					congrats.steps[3] = true
				end
			end
		end
		if congrats.timer > 4.5 then
			if congrats.oneLife == true then
				congrats.bonus = congrats.bonus + congrats.bonusOL
				congrats.oneLife = false
			end
		end
		if player.grandSlam == true then
			congrats.steps[4] = true
			if congrats.timer > 5 then
				player.grandSlam = false
				TEsound.play("sfx/element.ogg")
				congrats.grandSlam = true
			end
		else
			if congrats.steps[1] == true and congrats.steps[2] == true and congrats.steps[3] == true and congrats.steps[4] == false then
				if congrats.timer < 5 then
					congrats.timer = 6
					congrats.steps[4] = true
				end
			end
		end
		if congrats.timer > 6 then
			if congrats.grandSlam == true then
				congrats.steps[5] = true
				TEsound.play("sfx/element.ogg")
				congrats.bonus = congrats.bonus + congrats.bonusGS
				congrats.grandSlam = false
			end
		else
			if congrats.steps[1] == true and congrats.steps[2] == true and congrats.steps[3] == true and congrats.steps[4] == true and congrats.steps[5] == false then
				if congrats.timer < 7 then
					congrats.timer = 7
					congrats.steps[5] = true
				end
			end
		end
		if congrats.timer > 7 then
			if congrats.final == false then
				congrats.steps[6] = true 
				TEsound.play("sfx/element.ogg")
				player.score = player.score + congrats.bonusNC
				congrats.final = true
			end
		else
			if congrats.steps[1] == true and congrats.steps[2] == true and congrats.steps[3] == true and congrats.steps[4] == true and congrats.steps[5] == true and congrats.steps[6] == false then
				if congrats.timer > 8 then
					congrats.timer = 8
				end
			end
		end
	end
end
function Congrats.draw()
	love.graphics.setColor(255, 255, 255, congrats.alpha)
	if congrats.timer < 9 then
		love.graphics.setFont(font.lives)
		love.graphics.printf("FINAL SCORE", 0, 100, 768, "center")
		love.graphics.setFont(font.normal)
		love.graphics.printf(player.score, 0, 175, 768, "center")
	else
		love.graphics.setFont(font.normal)
		love.graphics.printf("CONGRATULATIONS", 0, window.height / 3, window.width, "center")
		love.graphics.setFont(font.lives)
		love.graphics.printf("You have completed this lame game, now get back to work!", window.width * 0.125, window.height / 2, window.width * 0.75, "center")
	end
	if congrats.final == false then
		love.graphics.setFont(font.lives)
		love.graphics.printf("FINAL BONUS", 0, 275, 768, "center")
	end
	if congrats.final == false then
		love.graphics.setFont(font.normal)
		love.graphics.printf(congrats.bonus, 0, 350, 768, "center")
	end
	if congrats.lives == true then
		love.graphics.draw(paddle.icon, congrats.x, 550)
		love.graphics.setFont(font.lives)
		love.graphics.print(player.lives, congrats.x + 60, 540)
		love.graphics.print("X", congrats.x + 115, 540)
		love.graphics.printf("STOCK BONUS", 0, 450, 768, "center")
		love.graphics.setFont(font.normal)
		love.graphics.printf(congrats.bonusL, 100, 525, 768, "center")
	end
	if congrats.noContinue == true then
		love.graphics.setFont(font.lives)
		love.graphics.printf("NO CONTINUE!", 0, 450, 768, "center")
		love.graphics.setFont(font.normal)
		love.graphics.printf(congrats.bonusNC, 0, 525, 768, "center")
	end
	if congrats.oneLife == true then
		love.graphics.setFont(font.lives)
		love.graphics.printf("ONE LIFE PLAY!!", 0, 450, 768, "center")
		love.graphics.setFont(font.normal)
		love.graphics.printf(congrats.bonusOL, 0, 525, 768, "center")
	end
	if congrats.grandSlam == true then
		love.graphics.setFont(font.lives)
		love.graphics.printf("GRAND SLAM PERFECT!!!", 0, 450, 768, "center")
		love.graphics.setFont(font.normal)
		love.graphics.printf(congrats.bonusGS, 0, 525, 768, "center")
	end
end
function Congrats.keypressed(key)
	if congrats.timer > 9 then
		Game.checkScore()
	end
end
function Score.update(dt)
	if scores.input == true then
		scores.timer = scores.timer + dt
		if scores.timer > 1 then
			scores.timer = 0
		end
	else
		local t = {}
		t.name = scores.name
		t.value = player.score
		if menu.complete == true then
			t.level = level - 1
			t.complete = "yes"
		else
			t.level = level
			t.complete = "no"
		end
		if scores.type == "high" then
			table.insert(scores.best, scores.index, t)
			table.remove(scores.best, 11)
			table.save(scores.best, "scores_best.lua")
		elseif scores.type == "low" then
			table.insert(scores.worst, scores.index, t)
			table.remove(scores.worst, 11)
			table.save(scores.worst, "scores_worst.lua")
		end
		scores.timer = 0
		scores.name = ""
		scores.length = 0
		scores.type = "nothing"
		scores.index = 0
		menu.complete = false
		player.score = 0
		level = 1
		game.state = "title"
	end
end
function Score.draw(title, text)
	love.graphics.draw(scores.panel, 184, 534)
	love.graphics.setFont(font.normal)
	prints(title, 0, 256, 8, 8, 768, "center")
	love.graphics.setFont(font.lives)
	prints(text, 20, 384, 4, 4, 728, "center")
	prints("Please enter your name and press Enter.", 20, 424, 8, 8, 728, "center")
	love.graphics.setColor(128, 128, 128)
	love.graphics.setFont(font.name)
	love.graphics.printf(scores.name, 180, 534, 400, "center")
	if scores.timer > 0.5 then
		love.graphics.printf("|", 384 + scores.length / 2, 534, 400, "left")
	end
	love.graphics.setColor(255, 255, 255)
end
function Score.keypressed(key)
	if scores.input == true then
		local l = string.len(scores.name)
		for _, v in pairs(editor.characters, key) do
			if v == key then
				if scores.length < 280 then
					scores.name = scores.name..key
					scores.length = font.name:getWidth(scores.name)
				end
			end
		end
		if key == "backspace" then
			scores.name = string.sub(scores.name, 1, l-1)
			scores.length = font.name:getWidth(scores.name)
		elseif key == "return" then
			if l > 0 then
				scores.input = false
			end
		end
	else

	end
end
function Debug.load()
	test = 0
end
function Debug.update(dt)
	test = pointer.x
end
function Debug.draw()
	love.graphics.setFont(font.debug)
	love.graphics.print(tostring(love.timer.getFPS()).." FPS", 10, 50)
	love.graphics.print("Dialog save: "..tostring(editor.dialog.save), 10, 60)
	love.graphics.print("Editor pointer: "..editor.pointer, 10, 70)
	love.graphics.print(tostring(test), 10, 80)
	love.graphics.setColor(255, 0, 0)
	love.graphics.setColor(255, 255, 255)
end
function prints(text, x, y, ox, oy, limit, align)
	local X = x + ox
	local Y = y + oy
	if limit == nil then
		love.graphics.setColor(0, 0, 0, 128)
		love.graphics.print(text, X, Y)
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.print(text, x, y)
	else
		love.graphics.setColor(0, 0, 0, 128)
		love.graphics.printf(text, X, Y, limit, align)
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.printf(text, x, y, limit, align)
	end
end
function Menu.selectPack(position, index)
	if index == nil then
		game.path = "Default levels"
		game.custom = false
	else
		game.path = "levels/"..menu.levels[index]
		game.custom = true
	end
	TEsound.play("sfx/click.ogg")
	menu.dialog.selected = true
	menu.dialog.sy = position
end
function Menu.setVideo()
	-- body
end